
//     Ŀ
//      Data scrolling driver for DJGPP version of diskmag Vyhen 
//                        code: HH/AA (C) 1997                   
//     

#include <dos.h>
#include <string.h>
#include <sys/movedata.h>
#include <unistd.h>
#include "vyhen.h"

extern volatile int set_start_addr, dist_line, scroll_line,
                    last_line, o_last_line;

extern byte (*scroll_buffer)[S_X*2],
       split_buffer[MAX_SPLIT][S_X*2],
       pal[768], pal2[768];

struct driver dsc_driver;
static int o_s=-1,o_x,o_y;

static int dsc_init(void)
{
 vmode(3);
 s_y=dsc_driver.s_y=25;

 v_set_font(FONT_DATA);

 hide_cursor();

 v_set_mouse_range(0,0,S_X-1,s_y-1);

 set_rgb(5,40,0,0);
 get_pal(pal);
 return 1;
}

static void dsc_exit(void)
{
 vmode(3);
}

static int blackscreen=0;

static void dsc_hide_text(void)
{
 int i;
 char c[S_X*2];
 v_hide_mouse();
 if(!blackscreen) {
 memset(c,0,sizeof(c));
 for (i=0;i<=s_y/2;i++)
     dosmemput(c,S_X*2,SEG_B800+i*S_X*2),
     dosmemput(c,S_X*2,SEG_B800+(s_y-i-1)*S_X*2),
     delay(30);
 blackscreen=1;
 }
}

static void do_display_text(void)
{
  char data[s_y][S_X*2];
  int size,i;
  memset(data,0,S_X*2*s_y);
  size=s_y-dsc_driver.split_size;
  if (size+dsc_driver.s_start>last_line) size=last_line-dsc_driver.s_start;
  if (size>0) memcpy(data,&scroll_buffer[dsc_driver.s_start],S_X*2*size);
  if (!blackscreen)
     dosmemput(data,S_X*2*(s_y-dsc_driver.split_size),SEG_B800); else
     for (i=0;i<=s_y/2;i++)
         dosmemput(&data[s_y/2-i][0],S_X*2,SEG_B800+(s_y/2-i)*S_X*2),
         dosmemput(&data[s_y/2+i][0],S_X*2,SEG_B800+(s_y/2+i)*S_X*2),
         delay(30);
  blackscreen=0;
}

static void dsc_display_text(void)
{
  do_display_text();
  v_show_mouse();
}

static void dsc_set_scrollpos(int i)
{
  if(dsc_driver.s_start!=i) {
     v_hide_mouse();
     dsc_driver.s_start=i;
     do_display_text();
     v_show_mouse();
     }
  dsc_driver.scroll_pos=i;
}

void dsc_update_buffer(void)
{
 scroll_line=0; /* aby se sprave vykreslovala mys */
 if(!blackscreen)
    do_display_text();
 if((dsc_driver.scroll_range=(last_line-s_y))<0) dsc_driver.scroll_range=0;
}

static void dsc_update_split(void)
{
  dosmemput(split_buffer,S_X*dsc_driver.split_size*2,SEG_B800+S_X*2*(s_y-dsc_driver.split_size));
}

void dsc_set_splitsize(int s)
{
  dsc_driver.split_size=s;
  v_hide_mouse();
  do_display_text();
  dsc_update_split();
  if(s>1) {
    v_set_mouse_range(0,0,S_X-1,s-2);
    o_s=scroll_line;
    o_x=mouse_x;
    o_y=mouse_y;
    scroll_line=s_y-dsc_driver.split_size+1;
  } else if (o_s!=-1) {
    scroll_line=o_s;
    v_set_mouse_range(0,0,S_X-1,s_y-1);
    v_set_mouse(o_x,o_y);
    o_s=-1;
  }
  delay(180);
  v_show_mouse();
}

void dsc_update_mouse(void)
{

 v_read_mouse();
 if (o_mouse_x!=mouse_x || o_mouse_y!=mouse_y ||
     o_scroll_line!=scroll_line) {
     if (mode_hidemouse)
        do_not_show_mouse=(o_mouse_x==mouse_x && o_mouse_y==mouse_y);
    v_hide_mouse();
    v_show_mouse();
    }

}

void dsc_scroll(int dirrection, int speed)
{ int p=dsc_driver.scroll_pos;
  if (mode_hidemouse) do_not_show_mouse=1;
  switch(speed)
  {
   case SPEED_NORMAL: p+=dirrection;delay(15);break;
   case SPEED_SWAP: p+=dirrection*4;delay(15);break;
   case SPEED_PAGE: {
     dist_line=dsc_driver.scroll_pos+s_y*dirrection;
     if (dist_line<0) dist_line=0;
     if (dist_line>dsc_driver.scroll_range) dist_line=dsc_driver.scroll_range;
     dsc_set_scrollpos(dist_line);
     draw_per();
     delay(150);
   }
   return;
   case SPEED_MAX:
    if(dirrection>0) p=dsc_driver.scroll_range; else p=0;
    break;
  }
  if(p>dsc_driver.scroll_range) p=dsc_driver.scroll_range;
  if(p<0) p=0;
  dsc_set_scrollpos(p);
}

struct driver dsc_driver=
{
  dsc_init,
  dsc_exit,
  dsc_update_buffer,
  dsc_update_split,
  dsc_display_text,
  dsc_hide_text,
  dsc_update_mouse,
  dsc_set_scrollpos,
  dsc_scroll,
  dsc_set_splitsize
  };
