
//          Ŀ
//             GIF decoder for DJGPP version of diskmag Vyhen   
//                       code: ReDox/MovSD (C) 1997             
//          

//    Ŀ
//                      Fuck off CompuServe licnese!                
//            Pictures in old Vyhen's data-files are NOT GIFs,      
//      because of different signature: `' instead `GIF87a'. 
//    

/************************************************/
/**                                            **/
/**    GIF Decoding and Encoding routines      **/
/**                                            **/
/**     Written by Tristan Tarrant, 1994       **/
/**                                            **/
/**        ( Supports GIF87a/GIF89a )          **/
/**                                            **/
/**  Changed and bugfixed for DJGPP version    **/
/**   of diskmag Vyhen by Daniel Sykora        **/
/**        (a.k.a ReDox/MovSD), 1997           **/
/**                                            **/
/************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <dpmi.h>
#include <string.h>
#include <mem.h>
#include <dos.h>
#include <dir.h>
#include <malloc.h>
#include <allegro.h>
#include "vyhen.h"

#define GOOD_READ       0
#define BAD_FILE        1
#define BAD_READ        2
#define UNEXPECTED_EOF  3
#define BAD_CODE        4
#define BAD_FIRSTCODE   5
#define BAD_ALLOC       6
#define BAD_SYMBOLSIZE  7

#define NO_CODE         -1

#define largest_code    4095
#define table_size      5003

typedef struct {
        unsigned char r,g,b;
        } color;

typedef struct {
        char sig[6];
        unsigned short int screenwidth, screendepth;
        unsigned char flags, background, aspect;
        } GIFHEADER;

typedef struct {
        unsigned short left, top, width, depth;
        unsigned char flags;
        } IMAGEBLOCK;

typedef struct {
        short width, depth, bits;
        short flags;
        short background;
        signed char palette[768];
        short (*setup)();
        short (*closedown)();
        short (*saveline)();
        short (*saveext)();
        } FILEINFO;

typedef struct {
        signed char blocksize;
        signed char flags;
        unsigned short delay;
        signed char transparent_colour;
        signed char terminator;
        } CONTROLBLOCK;

typedef struct {
        signed char blocksize;
        unsigned short left, top;
        unsigned short gridwidth, gridheight;
        signed char cellwidth, cellheight;
        signed char forecolour, backcolour;
        } PLAINTEXT;

typedef struct {
        signed char blocksize;
        signed char applstring[8];
        signed char authentication[3];
        } APPLICATION;

static BITMAP *bm;
static color pal[256],pal2[256];
static FILEINFO fi;int t,xres,yres;

void putline (unsigned char *p, short n)
{
  if (n >= 0 && n < fi.depth) {
     //bm->dat=p;bm->line[0]=p;
     //memcpy(bm->dat,p,fi.width);
     blit(bm,screen,0,0,(xres-fi.width)/2,(yres-fi.depth)/2+n,fi.width,1);
     }
}

void putextension (FILE *fp)
{
  PLAINTEXT pt;
  CONTROLBLOCK cb;
  APPLICATION ap;
  short c, n, i;

  fread (&c, 1, 1, fp);
  switch (c) {
    case 0x0001 : fread (&pt.blocksize,  1, 1, fp);
                  fread (&pt.left,       1, 2, fp);
                  fread (&pt.top,        1, 2, fp);
                  fread (&pt.gridwidth,  1, 2, fp);
                  fread (&pt.gridheight, 1, 2, fp);
                  fread (&pt.cellwidth,  1, 1, fp);
                  fread (&pt.cellheight, 1, 1, fp);
                  fread (&pt.forecolour, 1, 1, fp);
                  fread (&pt.backcolour, 1, 1, fp);
                  do {
                    if ((n = fgetc(fp)) != EOF)
                    {
                      for (i = 0; i < n; i++)
                        fgetc (fp);
                    }
                  } while (n > 0 && n != EOF);
                  break;
    case 0x0009 : fread (&cb.blocksize,          1, 1, fp);
                  fread (&cb.flags,              1, 1, fp);
                  fread (&cb.delay,              1, 1, fp);
                  fread (&cb.transparent_colour, 1, 1, fp);
                  fread (&cb.terminator,         1, 1, fp);
                  break;
    case 0x00fe : do {
                    if ((n = fgetc (fp)) != EOF)
                    {
                      for (i = 0; i < n; i++)
                        fgetc (fp);
                    }
                  } while (n > 0 && n != EOF);
                  break;
    case 0x00ff : fread ((char *)&ap, 1, sizeof(APPLICATION), fp);
                  do {
                    if ((n = fgetc (fp)) != EOF)
                    {
                      for (i = 0; i < n; i++)
                        fgetc (fp);
                    }
                  } while (n > 0 && n != EOF);
                  break;
    default :     if ((n = fgetc (fp)) != EOF)
                  {
                    for (i = 0; i < n; i++)
                      fgetc (fp);
                  }
                  break;
  }
}


short unpackimage (FILE *fp, short bits)
{
  short bits2;
  short codesize;
  short codesize2;
  short nextcode;
  short thiscode;
  short oldtoken;
  short currentcode;
  short oldcode;
  short bitsleft;
  short blocksize;
  short line = 0;
  short byte = 0;
  short pass = 0;

  unsigned char *p;
  unsigned char *q;
  unsigned char b[255];
  unsigned char *u;
  unsigned char *linebuffer;

  static unsigned char firstcodestack[4096];
  static unsigned char lastcodestack[4096];
  static short codestack[4096];

  static short wordmasktable[] = { 0x0000, 0x0001, 0x0003, 0x0007,
                                   0x000f, 0x001f, 0x003f, 0x007f,
                                   0x00ff, 0x01ff, 0x03ff, 0x07ff,
                                   0x0fff, 0x1fff, 0x3fff, 0x7fff };

  static short inctable[] = { 8, 8, 4, 2, 0 };
  static short startable[] = { 0, 4, 2, 1, 0 };

  p = q = b;
  bitsleft = 8;

  if (bits < 2 || bits > 8)
    return (BAD_SYMBOLSIZE);
  bits2 = 1 << bits;
  nextcode = bits2 + 2;
  codesize2 = 1 << (codesize = bits + 1);
  oldcode = oldtoken = NO_CODE;

//  if ((linebuffer = malloc (fi.width)) == NULL)
  //  return (BAD_ALLOC);
  linebuffer=bm->dat;

  line = 0;

  /* loop until something breaks */
  for (;;) {
    if (bitsleft == 8) {
      if (++p >= q && (((blocksize = fgetc(fp)) < 1) ||
         (q=(p=b)+fread (b, 1, blocksize, fp)) < (b+blocksize))) {
        //free (linebuffer);
        return (UNEXPECTED_EOF);
      }
      bitsleft = 0;
    }
    thiscode = *p;
    if ((currentcode = (codesize+bitsleft)) <= 8) {
      *p >>= codesize;
      bitsleft = currentcode;
    }
    else {
      if (++p >= q && (((blocksize = fgetc(fp)) < 1) ||
         (q=(p=b)+fread (b, 1, blocksize, fp)) < (b+blocksize))) {
        //free (linebuffer);
        return (UNEXPECTED_EOF);
      }
      thiscode |= *p << (8 - bitsleft);
      if (currentcode <= 16)
        *p >>= (bitsleft = currentcode - 8);
      else {
        if (++p >= q && (((blocksize = fgetc(fp)) < 1) ||
           (q=(p=b)+fread (b, 1, blocksize, fp)) < (b+blocksize))) {
          //free (linebuffer);
          return (UNEXPECTED_EOF);
        }
        thiscode |= *p << (16 - bitsleft);
        *p >>= (bitsleft = currentcode - 16);
      }
    }
    thiscode &= wordmasktable[codesize];
    currentcode = thiscode;

    if (thiscode == (bits2+1))
      break;
    if (thiscode > nextcode) {
      //free (linebuffer);
      return (BAD_CODE);
    }

    if (thiscode == bits2) {
      nextcode = bits2 + 2;
      codesize2 = 1 << (codesize = (bits + 1));
      oldtoken = oldcode = NO_CODE;
      continue;
    }

    u = firstcodestack;

    if (thiscode == nextcode) {
      if (oldcode == NO_CODE) {
        //free (linebuffer);
        return (BAD_FIRSTCODE);
      }
      *u++ = oldtoken;
      thiscode = oldcode;
    }

    while (thiscode >= bits2) {
      *u++ = lastcodestack [thiscode];
      thiscode = codestack[thiscode];
    }

    oldtoken = thiscode;
    do {
      linebuffer[byte++] = thiscode;
      if (byte >= fi.width) {
        putline (linebuffer, line);
        byte = 0;
        /* check for interlaced image */
        if (fi.flags & 0x40) {
          line += inctable[pass];
          if (line >= fi.depth)
            line = startable[++pass];
        } else ++line;
      }
      if (u <= firstcodestack)
        break;
      thiscode = *--u;
    } while (1);

    if (nextcode < 4096 && oldcode != NO_CODE) {
      codestack[nextcode] = oldcode;
      lastcodestack[nextcode] = oldtoken;
      if (++nextcode >= codesize2 && codesize < 12)
        codesize2 = 1 << ++codesize;
    }
    oldcode = currentcode;
  }
  //free (linebuffer);
  return (GOOD_READ);
}


int loadgif(char *filename, long gif_position)
{
  GIFHEADER gh;
  IMAGEBLOCK iblk;

  short b,c;
  FILE *libf;

  if  ((libf = fopen (filename, "rb")) == NULL)
      return -1;

  fseek(libf,gif_position,SEEK_SET);

  fread(&gh.sig,         1, 6, libf);
  fread(&gh.screenwidth, 1, 2, libf);
  fread(&gh.screendepth, 1, 2, libf);
  fread(&gh.flags,       1, 1, libf);
  fread(&gh.background,  1, 1, libf);
  fread(&gh.aspect,      1, 1, libf);

/*  if (memcmp(gh.sig, "GIF", 3))
  {
    fclose (libf);
    return -1;
  }*/

  /* get screen dimensions */
  fi.width = gh.screenwidth;
  fi.depth = gh.screendepth;

  xres = fi.width;
  yres = fi.depth;

  /*
  stdm-> 320x200.
  vesa-> 640x480,800x600.
  xmod-> 320x240,320x400,320x480,
         320x600,360x200,360x240,
         360x400,360x480,360x600.
  */

  if (xres==640 && yres==400) yres=480;
  if (xres<=320 && yres<=200) { xres=320; yres=200; }

  //vmode(3);
  //hide_cursor();
  change_sync_rate(yres);
  if (set_gfx_mode(GFX_AUTODETECT,xres,yres,0,0)!=0) return -1;
  clear(screen);
  memset(pal2,0,768);
  set_pal((byte *)pal2);

  fi.bits = (gh.flags & 0x0007) + 1;
  /* get colour map if there is one */
  if (gh.flags & 0x80) {
    c = 3 * (1 << ((gh.flags & 7) + 1));
    if ((short)fread (pal, 1, c, libf) != c)
    {
      fclose (libf);
      return -1;
    }
  }
  /* step through the blocks */
  while ((c=fgetc(libf))==',' || c=='!' || c==0) {
    /* if it's an image block */
    if (c == ',') {
      /* get the start of the image block */
      fread (&iblk.left,  1, 2, libf);
      fread (&iblk.top,   1, 2, libf);
      fread (&iblk.width, 1, 2, libf);
      fread (&iblk.depth, 1, 2, libf);
      fread (&iblk.flags, 1, 1, libf);

      /* get the image dimensions */
      fi.width = iblk.width;
      fi.depth = iblk.depth;

      /* get the local colour map if there is one */
      if (iblk.flags & 0x80) {
        b = 3 * (1 << ((iblk.flags & 0x0007) + 1));
        if ((short)fread (pal, 1, b, libf) != (int) c)
        {
          fclose (libf);
          return -1;
        }
        fi.bits = (iblk.flags & 0x0007) + 1;
      }

      /* get the initial code size */
      if (fread (&c, 1, 1, libf) == 0)
      {
        fclose (libf);
        return -1;
      }

      fi.flags = iblk.flags;

      if ((bm = create_bitmap(fi.width,1)) == NULL)
      {
        fclose (libf);
        return -1;
      }

      for (b = 0; b < 256; b++)
      {
        pal[b].r >>= 2;
        pal[b].g >>= 2;
        pal[b].b >>= 2;
      }
      t = unpackimage (libf, c);
      if (t != GOOD_READ)
      {
        destroy_bitmap(bm);
        fclose (libf);
        return -1;
      }
      else {
        destroy_bitmap(bm);
        fclose (libf);
        return 0;
      }
    }
    else if (c == '!')
      putextension (libf);
  };
  destroy_bitmap(bm);
  fclose (libf);
  return 0;
}

void g_fade_in()
{
 int i,j;
 memset(pal2,0,768);
 set_pal((byte *)pal2);
 for (j=0;j<=31;j++) {
     for (i=0;i<=255;i++) {
         if (pal2[i].r+2 <= pal[i].r) pal2[i].r+=2; else pal2[i].r=pal[i].r;
         if (pal2[i].g+2 <= pal[i].g) pal2[i].g+=2; else pal2[i].g=pal[i].g;
         if (pal2[i].b+2 <= pal[i].b) pal2[i].b+=2; else pal2[i].b=pal[i].b;
         }
     sync_wait();
     set_pal((byte *)pal2);
     }
 set_pal((byte *)pal);
}

void g_fade_out()
{
 int i,j;
 memcpy(pal2,pal,768);
 for (j=0;j<=31;j++) {
     for (i=0;i<=255;i++) {
         if (pal2[i].r-2 >= 0) pal2[i].r-=2; else pal2[i].r=0;
         if (pal2[i].g-2 >= 0) pal2[i].g-=2; else pal2[i].g=0;
         if (pal2[i].b-2 >= 0) pal2[i].b-=2; else pal2[i].b=0;
         }
     sync_wait();
     set_pal((byte *)pal2);
     }
}

int show_gif(char *gif_name)
{
FILE *f;
long gif_position;
char file_name[128];

if ((f=fopen(gif_name,"rb"))==NULL) {
    gif_position=atol(gif_name)+pictures_offset;
    strcpy(file_name,data_name);
    } else {
    fclose(f);
    gif_position=0;
    strcpy(file_name,gif_name);
    }

if (loadgif(file_name,gif_position)==-1) return -1;

g_fade_in();
while (!key[KEY_ESC] &&
       !(key[KEY_CONTROL] && key[KEY_LEFT]) &&
       !right_pressed) v_read_mouse();
g_fade_out();

clear(screen);
//set_gfx_mode(GFX_TEXT,80,25,0,0);
change_sync_rate(mode_stdvga ? 400 : 480);
return 0;
}
