
//     Ŀ
//      Hardware scrolling driver for DJGPP version of diskmag Vyhen 
//                   code: ReDox/MovSD & HH/AA (C) 1997              
//     


#include <dos.h>
#include <string.h>
#include <sys/movedata.h>
#include "vyhen.h"
#define MAX_SCROLLLINES (MAX_LINES-MAX_SPLIT)
volatile char micro_line=0;
volatile int set_start_addr, dist_line, scroll_line,
             last_line, hardware_scrolling_enabled,
             o_last_line;
extern byte (*scroll_buffer)[S_X*2], split_buffer[MAX_SPLIT][S_X*2],
       pal[768], pal2[768];

static int blackscreen=1;
struct driver hsc_driver;
static int o_s,o_x,o_y;

static void v_fade_in()
{
 int i,j;
 if(blackscreen) {
 while(set_start_addr) sync_wait();
 blackscreen=0;
 set_start_addr=1;
 memset(pal2,0,768);
 set_pal(pal2);
 sync_wait();
 hardware_scrolling_enabled=0;
 for (j=0;j<=32;j++) {
     for (i=0;i<=767;i+=3) {
         if (pal2[i+0]+2 <= pal[i+0]) pal2[i+0]+=2; else pal2[i+0]=pal[i+0];
         if (pal2[i+1]+2 <= pal[i+1]) pal2[i+1]+=2; else pal2[i+1]=pal[i+1];
         if (pal2[i+2]+2 <= pal[i+2]) pal2[i+2]+=2; else pal2[i+2]=pal[i+2];
         }
     split(s_y*16-(hsc_driver.split_size*16*j/32));
     sync_wait();
     set_pal(pal2);
     }
 set_pal(pal);
 button_blink=1;
 hardware_scrolling_enabled=1;
 }
 sync_wait();
}

static void v_fade_out()
{
 int i,j;
 if(!blackscreen) {
 hardware_scrolling_enabled=0;
 button_blink=0;
 memcpy(pal2,pal,768);
 for (j=0;j<=32;j++) {
     for (i=0;i<=767;i+=3) {
         if (pal2[i+0]-2 >= 0) pal2[i+0]-=2; else pal2[i+0]=0;
         if (pal2[i+1]-2 >= 0) pal2[i+1]-=2; else pal2[i+1]=0;
         if (pal2[i+2]-2 >= 0) pal2[i+2]-=2; else pal2[i+2]=0;
         }
     if (hsc_driver.split_size) split(s_y*16-(hsc_driver.split_size*16*(31-j)/32));
     sync_wait();
     set_pal(pal2);
     }
 hardware_scrolling_enabled=1;
 blackscreen=1;
 }
}

static int hsc_init(void)
{

 vmode(3);
 scroll_line=MAX_SPLIT;
 hsc_driver.scroll_pos=0;
 hsc_driver.s_start=0;

 if (!mode_stdvga)
    set_mode_80x30(),hsc_driver.s_y=30;
    else s_y=hsc_driver.s_y=25;

 set_rgb(5,40,0,0);
 get_pal(pal);

 memset(pal2,0,768);
 set_pal(pal2);

 v_set_font(FONT_DATA);

 hide_cursor();

 v_set_mouse_range(0,0,S_X-1,s_y-1);

 hardware_scrolling_enabled=1;
 set_start_addr=1;

 return 1;
}

static void hsc_exit(void)
{
 vmode(3);
}

static void hsc_hide_text(void)
{
  v_hide_mouse();
  v_fade_out();
  hardware_scrolling_enabled = 0;
}

static void hsc_display_text(void)
{
  v_fade_in();
  v_show_mouse();
  hardware_scrolling_enabled = 1;
  set_start_addr = 1;
}

static int redraw;

static void redraw_area(int s,int e,int shift)
{int size;
   /*prekresli cast vram mezi s a e s posuvem shift*/
   size=e-s;
   if(s+size-shift>last_line) size=last_line-s+shift;
   if(size<s_y) size=s_y;
   dosmemput(&scroll_buffer[(s-shift)], S_X*size*2,SEG_B800+s*S_X*2);
}


static void hsc_set_scrollpos(int i)
{ int l;
  int shift;

  l = i/16;  /*HH tohle je podpora pro dlouhy clanky - scroll_line mi dava
               pozici obrazu v obrazovce, hsc_driver.s_start je pozice obrazu
               ve scroll bufferu - shift bude posuv*/
  shift=scroll_line-hsc_driver.s_start;
  l += shift;
  hsc_driver.s_start=i/16;
             /* Kdyz jsem minule posouval buffer, je nutny to dodelat -
                redraw bude na 1, pokud se uz obrazovka soupla, muzu celej
                buffer soupnout*/
  if(!set_start_addr&&redraw) {
      if(!(--redraw)) { /*Vypada to, ze to u -nomidas modu potrebuje dva
                        dva refreshe...tusis proc?*/
      redraw_area(MAX_SPLIT,MAX_LINES,shift);
      redraw=0;
      }
  }
  if(l<MAX_SPLIT) { /*HH dostali jsme se pred zacatek bufferu - hodime to na konec*/
                    /* funguje to nasledovne:
                         ###------------ (### je obrazovka, --- jsou stary data
                         ###---------XXX (XXX jsou novy data)
                       pak se nastavi redraw na 1 a pocka se na sync:
                         ------------### protoze je redraw na 1 dokresli
                       se zbytek:
                         XXXXXXXXXXXX### a muzeme dal scrolovat!
                    */
      shift+=MAX_SCROLLLINES-s_y-1;
      redraw_area(MAX_LINES-s_y-2,MAX_LINES,shift);
      redraw=2;
  }
  if(l>MAX_SCROLLLINES-s_y-1+MAX_SPLIT) { /*HH dostali jsme se za konec -
                                            hodime to na konec*/
      if(blackscreen) { /*Musi to byt delitelny, jinak by to na zacatku mohlo spadnout -
                          scroll buffer by se soupnul pred zacatek obrazovky*/
        v_hide_mouse();
        shift=hsc_driver.s_start/(MAX_SCROLLLINES-s_y-1)*(MAX_SCROLLLINES-s_y-1);
        if(shift+s_y+1>last_line) shift-=MAX_SCROLLLINES-s_y-1; /*tesne se to veslo*/
        shift=-shift+MAX_SPLIT;
        redraw_area(MAX_SPLIT,MAX_LINES,shift);
      } else {
        shift-=MAX_SCROLLLINES-s_y-1;
        redraw_area(MAX_SPLIT,MAX_SPLIT+s_y+2,shift);
        redraw=2;
      }
  }
  l = i/16+shift;
  if(scroll_line!=l)  scroll_line=l, set_start_addr=1;
  micro_line = i%16;
  hsc_driver.scroll_pos=i;
  sync_wait();
}

void hsc_set_splitsize(int s)
{ int i,step=1;

  if (s==SPLIT_MENU) {
    v_hide_mouse();
    hardware_scrolling_enabled=0;
    v_set_mouse_range(0,0,S_X-1,s-2);
    o_s=scroll_line;
    o_x=mouse_x;
    o_y=mouse_y;
    scroll_line=1;
    v_show_mouse();
  } else if (o_s) {
    v_hide_mouse();
    scroll_line=o_s;
    v_set_mouse_range(0,0,S_X-1,s_y-1);
    v_set_mouse(o_x,o_y);
    hardware_scrolling_enabled=1;
    v_show_mouse();
    o_s=0;
    }

  if(!blackscreen) {
  if(abs(s-hsc_driver.split_size)>1) step=4;
  if (s>hsc_driver.split_size) {
   for (i=hsc_driver.split_size*16;i<=s*16;i+=step)
       split(hsc_driver.s_y*16-i),sync_wait();
  } else {
   for (i=hsc_driver.split_size*16;i>=s*16;i-=step)
       split(hsc_driver.s_y*16-i),sync_wait();
   }
  }

  hsc_driver.split_size=s;

}

void hsc_update_buffer(void)
{
 redraw_area(MAX_SPLIT, MAX_LINES, scroll_line-hsc_driver.s_start);
 hardware_scrolling_enabled=1;
 if((hsc_driver.scroll_range=(last_line-s_y)*16)<0) hsc_driver.scroll_range=0;
}

static void hsc_update_split(void)
{
 dosmemput(split_buffer,S_X*2*MAX_SPLIT,SEG_B800);
}

void hsc_update_mouse(void)
{

 v_read_mouse();
 if (o_mouse_x!=mouse_x || o_mouse_y!=mouse_y ||
     o_scroll_line!=scroll_line) {
     if (mode_hidemouse)
        do_not_show_mouse=(o_mouse_x==mouse_x && o_mouse_y==mouse_y);
    v_hide_mouse();
    v_show_mouse();
    }

}

void hsc_scroll(int dirrection, int speed)
{ int p=hsc_driver.scroll_pos;
  if (mode_hidemouse) do_not_show_mouse=1;
  switch(speed)
  {
   case SPEED_NORMAL: p+=dirrection*SCROLL_SPEED;break;
   case SPEED_SWAP: p+=dirrection*SCROLL_SPEED*4;break;
   case SPEED_PAGE:
     dist_line=hsc_driver.scroll_pos+s_y*dirrection*16;
     if (dist_line<0) dist_line=0;
     if (dist_line>hsc_driver.scroll_range) dist_line=hsc_driver.scroll_range;
     while (hsc_driver.scroll_pos*dirrection<dist_line*dirrection) {
           p=hsc_driver.scroll_pos+SCROLL_SPEED*dirrection*2;
           if (p>hsc_driver.scroll_range) p=hsc_driver.scroll_range;
           if (p<0) p=0;
           v_hide_mouse();
           hsc_set_scrollpos(p);
           draw_per();
           v_show_mouse();
           }
   return;
   case SPEED_MAX:
     dist_line=0;if (dirrection==1) dist_line=hsc_driver.scroll_range;
     while (hsc_driver.scroll_pos*dirrection<dist_line*dirrection) {
           p=hsc_driver.scroll_pos+SCROLL_SPEED*dirrection*4;
           if (p>hsc_driver.scroll_range) p=hsc_driver.scroll_range;
           if (p<0) p=0;
           v_hide_mouse();
           hsc_set_scrollpos(p);
           draw_per();
           v_show_mouse();
           }
   return;
  }
  if(p>hsc_driver.scroll_range) p=hsc_driver.scroll_range;
  if(p<0) p=0;
  hsc_set_scrollpos(p);
}

struct driver hsc_driver=
{
  hsc_init,
  hsc_exit,
  hsc_update_buffer,
  hsc_update_split,
  hsc_display_text,
  hsc_hide_text,
  hsc_update_mouse,
  hsc_set_scrollpos,
  hsc_scroll,
  hsc_set_splitsize
  };
