
//          Ŀ
//             JPEG reader for DJGPP version of diskmag Vyhen    
//                        code: Jim Frost (C) 1991               
//          

/* #ident   "@(#)x11:contrib/clients/xloadimage/jpeg.c 1.19 94/07/29 Labtam" */
/*
 * jpeg - This file provides interface routines to connect xli to
 * the jpeg decoding routines taken from the Independent JPEG Group's
 * free JPEG software.  See build-jpeg for more information.
 *
 * This code is based on example.c from the IJG v4 distribution,
 * and the original xloadimage/xli jpeg.c for the IJG v1 distribution.
 */

#include <setjmp.h>             /* need setjmp/longjmp */
#include <ctype.h>
#include <fcntl.h>
#include <io.h>
#include <malloc.h>
#include <conio.h>
#define VYHEN_JPG
#include "vyhen.h"
#include <allegro.h>

BITMAP *bm;
char *file_name;
long jpg_position;
int xres,yres,ixres,iyres;

#ifdef VMS
#define NO_UNCOMPRESS /* VMS doesn't have uncompress */
#endif

FILE *popen();          /* ANSI C doesn't declare popen in stdio.h ! */

#define MAX_ZFILES 32
#define UULEN 128       /* uudecode buffer length */
#define UUSTARTLEN 100          /* Lines to look though before assuming not uuencoded */
int uuread();
int uugetline();
boolean uuCheck();
int uuExplodeLine();

/* this table is useful for quick conversions between depth and ncolors
 */

unsigned long DepthToColorsTable[] = {
  /*  0 */ 1,
  /*  1 */ 2,
  /*  2 */ 4,
  /*  3 */ 8,
  /*  4 */ 16,
  /*  5 */ 32,
  /*  6 */ 64,
  /*  7 */ 128,
  /*  8 */ 256,
  /*  9 */ 512,
  /* 10 */ 1024,
  /* 11 */ 2048,
  /* 12 */ 4096,
  /* 13 */ 8192,
  /* 14 */ 16384,
  /* 15 */ 32768,
  /* 16 */ 65536,
  /* 17 */ 131072,
  /* 18 */ 262144,
  /* 19 */ 524288,
  /* 20 */ 1048576,
  /* 21 */ 2097152,
  /* 22 */ 4194304,
  /* 23 */ 8388608,
  /* 24 */ 16777216,
  /* 25 */ 33554432,
  /* 26 */ 67108864,
  /* 27 */ 134217728,
  /* 28 */ 268435456,
  /* 29 */ 536870912,
  /* 30 */ 1073741824,
  /* 31 */ 2147483648,
  /* 32 */ 2147483648 /* bigger than unsigned int; this is good enough */
};

unsigned long colorsToDepth(ncolors)
     unsigned long ncolors;
{ unsigned long a;

  for (a= 0; (a < 32) && (DepthToColorsTable[a] < ncolors); a++)
    /* EMPTY */
    ;
  return(a);
}

char *dupString(s)
     char *s;
{ char *d;

  if (!s)
    return(NULL);
  d= (char *)lmalloc(strlen(s) + 1);
  strcpy(d, s);
  return(d);
}

void newRGBMapData(rgb, size)
     RGBMap       *rgb;
     unsigned int  size;
{
//  CURRFUNC("newRGBMapData");
  rgb->used= 0;
  rgb->size= size;
  rgb->compressed= FALSE;
  rgb->red= (Intensity *)lmalloc(sizeof(Intensity) * size);
  rgb->green= (Intensity *)lmalloc(sizeof(Intensity) * size);
  rgb->blue= (Intensity *)lmalloc(sizeof(Intensity) * size);
}

void resizeRGBMapData(rgb, size)
     RGBMap       *rgb;
     unsigned int  size;
{
//  CURRFUNC("resizeRGBMapData");
  rgb->red= (Intensity *)lrealloc(rgb->red, sizeof(Intensity) * size);
  rgb->green= (Intensity *)lrealloc(rgb->green, sizeof(Intensity) * size);
  rgb->blue= (Intensity *)lrealloc(rgb->blue, sizeof(Intensity) * size);
  rgb->size= size;      // new size
}

void freeRGBMapData(rgb)
     RGBMap *rgb;
{
//  CURRFUNC("freeRGBMapData");
  lfree((Byte *)rgb->red);
  lfree((Byte *)rgb->green);
  lfree((Byte *)rgb->blue);
}
/*
Image *newBitImage(width, height)
     unsigned int width, height;
{ Image        *image;
  unsigned int  linelen;

//  CURRFUNC("newBitImage");
  image= (Image *)lmalloc(sizeof(Image));
  image->type= IBITMAP;
  image->title= NULL;
  newRGBMapData(&(image->rgb), (unsigned int)2);
  *(image->rgb.red)= *(image->rgb.green)= *(image->rgb.blue)= 65535;
  *(image->rgb.red + 1)= *(image->rgb.green + 1)= *(image->rgb.blue + 1)= 0;
  image->rgb.used= 2;
  image->width= width;
  image->height= height;
  image->depth= 1;
  linelen= ((width + 7) / 8);
  image->data= (unsigned char *)lcalloc(linelen * height);
  image->gamma= 0.0;    // nonsense value
  return(image);
}

Image *newRGBImage(width, height, depth)
     unsigned int width, height, depth;
{ Image        *image;
  unsigned int  pixlen, numcolors;

//  CURRFUNC("newRGBImage");

  if (depth == 0) // special case for `zero' depth image, which is
    depth= 1;     // sometimes interpreted as `one color'
  pixlen= ((depth+7) / 8);
  numcolors = depthToColors(depth);
  image= (Image *)lmalloc(sizeof(Image));
  image->type= IRGB;
  image->title= NULL;
  newRGBMapData(&(image->rgb), numcolors);
  image->width= width;
  image->height= height;
  image->depth= depth;
  image->pixlen= pixlen;
  image->data= (unsigned char *)lmalloc(width * height * pixlen);
  image->gamma= 0.0;    // nonsense value
  return(image);
}

Image *newTrueImage(width, height)
     unsigned int width, height;
{ Image        *image;
//  CURRFUNC("NewTrueImage");
  image= (Image *)lmalloc(sizeof(Image));
  image->type= ITRUE;
  image->title= NULL;
  image->rgb.used= image->rgb.size= 0;
  image->width= width;
  image->height= height;
  image->depth= 24;
  image->pixlen= 3;
  image->data= (unsigned char *)lmalloc(width * height * 3);
  image->gamma= 0.0;    // nonsense value
  return(image);
}

void freeImageData(image)
     Image *image;
{
  if (image->title) {
    lfree((Byte *)image->title);
    image->title= NULL;
  }
  if (!TRUEP(image))
    freeRGBMapData(&(image->rgb));
  lfree(image->data);
}

void freeImage(image)
     Image *image;
{
  freeImageData(image);
  lfree((Byte *)image);
}
*/

Byte *lmalloc(size)
     unsigned int size;
{ Byte *area;

  if (size == 0) {
    size= 1;
//    if (globals._Xdebug)
  //    fprintf(stderr, "lmalloc given zero size!\n");
  }
  if (!(area= (Byte *)malloc(size))) {
//    memoryExhausted();
    /* NOTREACHED */
  }
  return(area);
}

Byte *lcalloc(size)
     unsigned int size;
{ Byte *area;

  if (size == 0) {
    size= 1;
 //   if (globals._Xdebug)
   //   fprintf(stderr, "lcalloc given zero size!\n");
  }
  if (!(area= (Byte *)calloc(1, size))) {
//    memoryExhausted();
    /* NOTREACHED */
  }
  return(area);
}

Byte *lrealloc(old,size)
     Byte *old;
     unsigned int size;
{ Byte *area;

  if (size == 0) {
    size= 1;
//    if (globals._Xdebug)
      //fprintf(stderr, "lrealloc given zero size!\n");
  }
  if (!(area= (Byte *)realloc(old,size))) {
//    memoryExhausted();
    /* NOTREACHED */
  }
  return(area);
}

void lfree(area)
     Byte *area;
{
  free(area);
}


static ZFILE ZFileTable[MAX_ZFILES];

int
zread(zf, buf, len)
     ZFILE *zf;
     Byte *buf;
     int len;
{
  int lentoread = len;
  struct cache *dataptr = zf->dataptr;

  while (len > 0 && !zf->eof)
  {
    /* Read any data in cache buffers or aux buffer */
    if (zf->bufptr < zf->endptr)
    {
      int readlen = zf->endptr - zf->bufptr;
      if (readlen > len)
        readlen = len;
      bcopy(zf->bufptr, buf, readlen);
      buf += readlen;
      len -= readlen;
      zf->bufptr += readlen;
      continue;
    }
    /* else we have run out of buffered data */

    /* If we were reading from an aux buffer, */
    /* retore the previous state */
    if (zf->auxb != NULL)
    {  /* restore previous buffer */
      if (zf->auxb != zf->buf)  /* if not getc buffer */
        lfree (zf->auxb);       /* was un-read buffer */
      zf->auxb= NULL;
      zf->bufptr = zf->oldbufptr;
      zf->endptr = zf->oldendptr;
      continue;
    }

    /* If this is a newly opened file or we are */
    /* no longer reading previously cached data */
    if (dataptr == NULL)
    {
      if (zf->nocache) /* If the cache is turned off, read directly */
      {
        if (len > 1)    /* more than a Byte being read */
        {
          len -= uuread(zf, buf, len);
          if (len > 0)
            zf->eof = TRUE;
          continue;
        }
        /* else we are reading one Byte directly - this is a little */
        /* inefficient :-). Buffer it instead. */
        zf->bufptr = zf->buf;
        zf->endptr = zf->bufptr + uuread(zf, zf->bufptr, BUFSIZ);
        if (zf->endptr == zf->bufptr)
          zf->eof = TRUE;
        continue;
      }
      /* else fall through to deal with first cached buffered read */
    }
    else  /* we must move on to the next cache buffer */
    {
      if (zf->bufptr == NULL) /* If this is a first re-read of the cache */
      {
        zf->bufptr = dataptr->buf;  /* init the pointers */
        zf->endptr = dataptr->end;
        continue;
      }

      /* If there are more buffers, then advance */
      /* to the next one */
      if (dataptr->next != NULL)
      {
        /* advance to the next buffer */
        dataptr = zf->dataptr = dataptr->next;
        zf->bufptr = dataptr->buf;
        zf->endptr = dataptr->end;
        continue;
      }
      /* There are no more buffers */
      if (dataptr->eof)
      {
        zf->eof = TRUE; /* we know that was the last one */
        continue;
      }
    }

    /* We have come to the end of the cache buffers or */
    /* we are doing the first cached read. */

    /* If the cache is off, switch it fully */
    /* out of the picture from now on */
    if (zf->nocache)  /* read directly */
    {
      zf->dataptr = dataptr = NULL;
      zf->bufptr = NULL;
      zf->endptr = NULL;
      continue;
    }

    /* We are caching and have to read another buffer or maybe we have */
    /* to read the very first buffer (zf->data and dataptr == NULL) */
    zf->dataptr= (struct cache *)lmalloc(sizeof(struct cache));
    zf->dataptr->next = NULL;
    zf->dataptr->eof = FALSE;
    if (zf->data == NULL)   /* If very first read */
      zf->data = zf->dataptr;   /* set to first allocated buffer */
    else                   /* link buffer into chain */
      dataptr->next = zf->dataptr;
    dataptr = zf->dataptr;
    zf->bufptr = dataptr->buf;
    zf->endptr = dataptr->end = zf->bufptr + uuread(zf, zf->bufptr, BUFSIZ);
    dataptr->eof = ((zf->endptr - zf->bufptr) < BUFSIZ);
  }
  return (lentoread - len);
}


/* append the given buffer data to the files read cache */
/* (Allows reading blocks directly from input stream while */
/*  maintaining cache data) */
void
_zaptocache(zf,cbuf,blen)
ZFILE *zf;
char *cbuf;
int blen;
{
  struct cache *newdat,*dat;
  int len;
  while(blen > 0) { /* until we've stashed all of input */
    len = blen;
    if (len > BUFSIZ)
      len = BUFSIZ;

    /* create new cache data block */
    newdat= (struct cache *)lmalloc(sizeof(struct cache));
    bcopy(cbuf,newdat->buf,len);
    newdat->end = newdat->buf + len;
    newdat->next = NULL;
    newdat->eof = FALSE;

    /* append it to cache buffers */
    if (zf->data == NULL) {  /* nothing read yet */
      zf->data = newdat;
      zf->dataptr= zf->data;
    } else {
      for(dat=zf->data;dat->next!= NULL;dat=dat->next); /* go to end of chain */
      dat->next = newdat;
      dat->eof = FALSE;
    }
    cbuf += len;
    blen -= len;
  }
}

/* Return the files EOF status */

int zeof(zf)
     ZFILE *zf;
{
  return zf->eof;
}

void zclearerr(zf)
     ZFILE *zf;
{
  clearerr((zf)->stream);
  zf->eof = 0;
}


/* reset a read cache (reset means really close the file)
 */

void zreset(filename)
     char *filename;
{
  int a;
  ZFILE *zf;

  /* if NULL filename, reset the entire table
   */

  if (!filename) {
    for (a= 0; a < MAX_ZFILES; a++)
      if (ZFileTable[a].filename)
        zreset(ZFileTable[a].filename);
    return;
  }

  for (zf= ZFileTable; zf < (ZFileTable + MAX_ZFILES); zf++)
    if (zf->filename && !strcmp(filename, zf->filename))
      break;

  if (zf == (ZFileTable + MAX_ZFILES)) /* no go joe */
    return;

  _zreset(zf);
}

/* reset by file descriptor */
void _zreset(zf)
     ZFILE *zf;
{
  struct cache *old;
  if (zf->dataptr != zf->data)
    //fprintf(stderr, "zreset: warning: ZFILE for %s was not closed properly\n",
  //         zf->filename);
  while (zf->data) {
    old= zf->data;
    zf->data= zf->data->next;
    free(old);
  }
  lfree((Byte *)zf->filename);
  zf->filename= NULL;
  zf->data= NULL;
  zf->dataptr= NULL;
  zf->nocache= FALSE;
  if (zf->auxb != NULL && zf->auxb != zf->buf)
    lfree((Byte *)zf->auxb);
  zf->auxb= NULL;
  zf->bufptr= NULL;
  zf->endptr= NULL;
  zf->eof= FALSE;

  switch(zf->type) {
  case ZSTANDARD:
    fclose(zf->stream);
    break;
#ifndef NO_UNCOMPRESS
  case ZPIPE:
    pclose(zf->stream);
    break;
#endif /* NO_UNCOMPRESS */
  case ZSTDIN:
    break;
  default:
    //fprintf(stderr, "zreset: bad ZFILE structure\n");
    exit(1);
  }
}

/* discard all data that has been read. Return to state just after file was opened */
void _zclear(zf)
     ZFILE *zf;
{
  struct cache *old;

  if (zf->auxb != NULL && zf->auxb != zf->buf)
    lfree(zf->auxb);

  while (zf->data) {
    old= zf->data;
    zf->data= zf->data->next;
    free(old);
  }
  zf->auxb= NULL;
  zf->bufptr= NULL;
  zf->endptr= NULL;
  zf->eof= FALSE;
  zf->data= NULL;
  zf->dataptr= NULL;
  zf->nocache= FALSE;
}

ZFILE *zopen(name)
     char *name;
{
  ZFILE *zf;

  /* look for filename in open file table
   */

  for (zf = ZFileTable; zf < (ZFileTable + MAX_ZFILES); zf++)
    if (zf->filename && !strcmp(name, zf->filename)) {

      /* if we try to reopen a file whose caching was disabled, warn the user
       * and try to recover.  we cannot recover if it was stdin.
       */

      if (zf->nocache) {
        if (zf->type == ZSTDIN) {
          //fprintf(stderr, "zopen: caching was disabled by previous caller; can't reopen stdin\n");
          return(NULL);
        }
        //fprintf(stderr, "zopen: warning: caching was disabled by previous caller\n");
        zreset(zf->filename);   /* remove entry and treat like new open */
        break;
      }
      if (zf->dataptr != zf->data)
        //fprintf(stderr, "zopen: warning: file doubly opened\n");
      zf->dataptr= zf->data;    /* re-start with cache if it exists */
      if (zf->auxb != NULL && zf->auxb != zf->buf)
        lfree((Byte *)zf->auxb);
      zf->auxb = NULL;
      zf->bufptr= NULL;
      zf->endptr= NULL;
      zf->eof= FALSE;
      return(zf);
    }

  /* find unused ZFileTable entry
   */

  for (zf = ZFileTable; zf < (ZFileTable + MAX_ZFILES) && zf->filename; zf++)
    /* EMPTY */
    ;

  if (zf >= (ZFileTable + MAX_ZFILES)) {
    //fprintf(stderr, "zopen: no more files available\n");
    exit(1);
  }

  zf->filename= dupString(name);
  if(!_zopen(zf))       /* failed */
  {
    lfree(zf->filename);
    zf->filename= NULL;
    return (NULL);
  }
  return (zf);
}

/* Find the length of a gets buffer */
/* Return the negative length if it looks like binary */
/* junk */
int
buflen(buf,len)
Byte *buf;
int len;
{
  int i,j=0;
  len--;        /* allow for '\000' at end */
  for (i=0;i<len && *buf != '\n';i++,buf++) {
    if (*buf == '\000')
      j=1;
  }
  if (i < len)
    i++;        /* count '\n' */
  if (j)
    return -i;
  return i;
}


/* Do an open given a file pointer */
/* Return TRUE if open suceeded */
boolean
_zopen(zf)
ZFILE *zf;
{
  char  buf[BUFSIZ];
  char *name = zf->filename;
  char  uuibuf[UULEN],uudest[UULEN],uudummy[UULEN];
  int   uumode,uutry = UUSTARTLEN;

  zf->data= NULL;
  zf->dataptr= NULL;
  zf->auxb= NULL;
  zf->bufptr= NULL;
  zf->endptr= NULL;
  zf->nocache= FALSE;
  zf->eof= FALSE;
  zf->uudecode= FALSE;

  /* file filename is `stdin' then use stdin
   */

  if (!strcmp(name, "stdin")) {
    zf->type= ZSTDIN;
    zf->stream= stdin;
#ifdef MSDOS
    setmode(fileno(stdin),O_BINARY);
#endif /* MSDOS */
  }
#ifndef NO_UNCOMPRESS
  /* if filename ends in `.Z' then open pipe to uncompress.  if your
   * system doesn't have uncompress you can define NO_UNCOMPRESS and
   * it just won't check for this.
   */

#ifdef HAVE_GUNZIP
  else if (  (strlen(name) > 3 && !strcasecmp(".gz", name + (strlen(name) - 3)))
          || (strlen(name) > 2 && !strcasecmp(".Z", name + (strlen(name) - 2)))) {
    sprintf(buf, "gunzip -c %s", name);
#else   /* #else its a unix compressed file, so use uncompress */
  else if ((strlen(name) > (unsigned)2) && !strcmp(".Z", name + (strlen(name) - 2))) {
    sprintf(buf, "uncompress -c %s", name);
#endif
    zf->type= ZPIPE;
    if (! (zf->stream= popen(buf, "r"))) {
        return(FALSE);
    }
  }
#endif

  /* default to normal stream
   */

  else {
    zf->type= ZSTANDARD;
    if (!
#ifdef VMS
        (zf->stream= fopen(name, "r", "ctx=bin", "ctx=stm", "rfm=stmlf"))
#else
#ifdef MSDOS
        (zf->stream= fopen(name, "rb"))
#else
        (zf->stream= fopen(name, "r"))
#endif
#endif
        ) {
      return(FALSE);
    }
     fseek(zf->stream,jpg_position,SEEK_SET);
  }

  /* File is now open, so see if it is a uuencoded file */
  while (uutry-- > 0) {
    if (fgets(uuibuf, UULEN, zf->stream) != NULL) {
      int blen;
      blen = buflen(uuibuf,UULEN);
      if (blen < 0) {   /* doesn't look like reasonable junk */
        _zaptocache(zf,uuibuf,-blen);
        break;
      }
      _zaptocache(zf,uuibuf,blen);      /* keep zfile data cached */
      if (!strncmp(uuibuf, "begin ", 6)
        && isdigit(uuibuf[6])
        && isdigit(uuibuf[7])
        && isdigit(uuibuf[8])) {
        /* Found a begin line */
        /* Extract filename and file mode       */
        if ((sscanf(uuibuf, "begin %o%[ ]%s", &uumode, uudummy, uudest)) != 3) {
          continue;     /* it's not right */
        }
        /* Need access to verbose flag to print the following */
        /* printf("uuencoded file '%s' being decoded\n",uudest); */
        _zclear(zf);    /* discard all data read */
        zf->uudecode = TRUE;
        zf->uunext = zf->uuend = &zf->uubuf[0];
        zf->uustate = UUBODY;
        return(TRUE);
      }
    }
  }

  /* Not uu encodede */
  return(TRUE);
}

/* The function zgetc, rather than the macro */
int _zgetc(zf)
     ZFILE *zf;
{ unsigned char c;

  if (zf->bufptr < zf->endptr)
        return *zf->bufptr++;
  if (zread(zf, &c, 1) > 0)
    return(c);
  else
    return(EOF);
}

char *zgets(buf, size, zf)
     char         *buf;
     unsigned int  size;
     ZFILE        *zf;
{
  if ((--size) <= 0)
        return NULL;
  {
    int ssize = zf->endptr - zf->bufptr;
    if (ssize > 0)
    {   /* can do this fast */
      register Byte *bp = zf->bufptr, *be;
      be = zf->bufptr + (size < ssize ? size : ssize);
      while (bp < be)
      {
        if (*bp++ == '\n')
          break;
      }
      if (bp < be || size < ssize)
      {
        bcopy(zf->bufptr,buf,bp - zf->bufptr);
        buf[bp - zf->bufptr] = '\000';
        zf->bufptr = bp;
        return ((char *)buf);
      }
    }
  }
  /* do this slower */
  {
    register char *cp = buf;
    register int c;
    while (cp < (buf + size) && (c  = zgetc(zf)) != EOF)
    {
      *cp++ = c;
      if (c == '\n')
        break;
    }
    if (cp > buf)
    {   /* we read something */
      *cp = '\000';
      return ((char *)buf);
    }
  }
  return(NULL);
}

/* Return a block of data back to the input stream.
 * Usefull if a load routine does its own buffering
 * and wants to return what is left after it has read an image.
 */
void
zunread(zf, buf, len)
     ZFILE *zf;
     Byte *buf;
     int len;
{
  Byte *new;
  int sizeaxb; /* size of aux buffer */
  int noinaxb; /* number unread in aux buffer */
  int nofraxb; /* number free in aux buffer */
  if (len == 0)
        return;
  if (zf->auxb != NULL) {
    sizeaxb = zf->endptr - zf->auxb;    /* size of aux buffer */
    noinaxb = zf->endptr - zf->bufptr;  /* number unread in aux buffer */
    nofraxb = zf->bufptr - zf->auxb;    /* number free in aux buffer */
  } else {
    zf->oldbufptr = zf->bufptr;
    zf->oldendptr = zf->endptr;
    sizeaxb = noinaxb = nofraxb = 0;
  }
  if (len <= nofraxb) { /* no need to alloc more */
    zf->bufptr -= len;
    bcopy (buf, zf->bufptr, len);
  } else {      /* need some more space */
    int extra = 0;
    if (len < 100)
      extra = 100;
    new = (Byte *)lmalloc(extra + noinaxb + len);
    bcopy (buf, new + extra , len);             /* copy new aux data */
    if (noinaxb != 0) {         /* copy old data */
      bcopy (zf->bufptr, new + extra + len, noinaxb);
      if (zf->auxb != NULL && zf->auxb != zf->buf)
        lfree(zf->auxb);
    }
    zf->auxb = new;
    zf->bufptr = new + extra;
    zf->endptr = new + extra + noinaxb + len;
  }
  zf->eof = FALSE;
}


/* this turns off caching when an image has been identified and we will not
 * need to re-open it
 */

void znocache(zf)
     ZFILE *zf;
{
  zf->nocache= TRUE;
}

/* reset cache pointers in a ZFILE.  nothing is actually reset until a
 * zreset() is called with the filename.
 */

void zclose(zf)
     ZFILE *zf;
{
  zf->dataptr= zf->data;
  if (zf->auxb != NULL && zf->auxb != zf->buf)
    lfree(zf->auxb);
  zf->auxb= NULL;
  zf->bufptr= NULL;
  zf->endptr= NULL;
  zf->eof= FALSE;
}

/* close the file and then re-open it. */
/* Return TRUE on sucess. */
boolean
_zreopen(zf)
     ZFILE *zf;
{
  char *tname;
  tname= dupString(zf->filename);
  _zreset(zf);
  zf->filename = tname;
  if(!_zopen(zf))       /* failed */
  {
    lfree(zf->filename);
    zf->filename= NULL;
    return (FALSE);
  }
  return (TRUE);
}

/* Rewind the cached file. Warn the user if
 * this is not likely to work.
 * Return TRUE on sucess.
 */

boolean
zrewind(zf)
     ZFILE *zf;
{
  if (zf->nocache) {
    if (zf->type == ZSTDIN) {
      //fprintf(stderr, "zrewind: caching was disabled by previous caller; can't rewind\n");
      return(FALSE);
    }
    //fprintf(stderr, "zrewind: warning: caching was disabled by previous caller\n");
    return !_zreopen(zf);
  }
  zf->dataptr= zf->data;
  if (zf->auxb != NULL && zf->auxb != zf->buf)
    lfree(zf->auxb);
  zf->auxb= NULL;
  zf->bufptr= NULL;
  zf->endptr= NULL;
  zf->eof= FALSE;
  return TRUE;
}

/* Read in a buffer from the possibly uuencoded input stream */
int
uuread(zf, buf, len)
     ZFILE *zf;
     Byte *buf;
     int len;
{
  int cl,ld=0;
  if (!zf->uudecode) {
    if(zf->type == ZSTANDARD)
      return fread(buf, 1, len, zf->stream);

    /* Work around for SVR4 fread() bug */
    for(;;) {
      ld += cl = fread(buf, 1, len-ld, zf->stream);
      if (ld == len)
        break;
      buf += cl;
      if (feof(zf->stream))
        break;
    }
  return ld;
  }

  for(;;) {
    if (zf->uunext >= zf->uuend) {      /* if buffer empty */
      zf->uunext = zf->uubuf;
      zf->uuend = zf->uubuf + uugetline(zf,zf->uubuf);
      if (zf->uunext >= zf->uuend) { /* nothing read */
        return ld;
      }
    }
    /* Copy what we got into the buffer */
    cl = zf->uuend - zf->uunext;        /* copy length */
    if (cl > (len-ld))
      cl = (len-ld);
    bcopy (zf->uunext, buf, cl);
    zf->uunext += cl;
    ld += cl;   /* bump length done */
    buf += cl;
    if (ld >= len) {    /* Finished */
      return ld;
    }
  }
}

/* Get a line of uudecoded bytes from the input stream */

#define SHORTALOWANCE 6         /* alowance for truncation of ' 's at the end of lines */

int
uugetline(zf,obuf)
ZFILE *zf;
Byte *obuf;
{
  int ulen,len;   /* number of uu encoding characters */
  Byte ibuf[UULEN]; /* raw line buffer */
  int nib=0;      /* number in buffer */

  for(;;) {     /* until we return something */
    if (zf->uustate == UUEOF) { /* there's nothing more to read */
      return 0;
    }
    if (fgets((char *)ibuf, UULEN, zf->stream) == NULL) {
      //fprintf(stderr,"uudecode: unexpected EOF\n");
      zf->uustate = UUEOF;
      return 0;
    }
    len = strlen((char *)ibuf)-2;
    ulen = ((int)(((*ibuf) - ' ') & 077) * 4 + 2)/3;
    if (*ibuf == 'M' && (len+SHORTALOWANCE) >= ulen && uuCheck(ibuf+1,ulen <= len ? ulen : len)) {
      if (len < ulen) {         /* we have a slightly short line */
        //fprintf(stderr,"uudecode: warning, short line\n");
        while(len < ulen)
          ibuf[++len] = ' ';
      }
      nib = uuExplodeLine(ibuf,obuf);
      zf->uustate = UUBODY;
      return nib;
    }

    /* Found a possibly dodgey line */
    if (zf->uustate == UUSKIP) {
      continue; /* Skip any non 'M' lines */
    }

    if ((*ibuf != ' ' && *ibuf != '`' ) || (len != 0 && len != 1)) {
      /* not a blank before end line */

      /* Is zf->uustate == UUBODY and possible dodgy line */
      if (*ibuf > 'L' || *ibuf <= ' ' || len < ulen || !uuCheck(ibuf+1,ulen)) {
        /* not a possible short line */
        zf->uustate = UUSKIP;
        continue;
      }

      nib = uuExplodeLine(ibuf,obuf);   /* decode possible short line */

      /* if this is a valid short line, then we expect a */
      /* specific line followed by an end line */
      if (fgets((char *)ibuf, UULEN, zf->stream) == NULL) {
        //fprintf(stderr,"uudecode: unexpected EOF\n");
        zf->uustate = UUEOF;
        return nib;
      }
      len = strlen((char *)ibuf)-2;
      ulen = ((int)(((*ibuf) - ' ') & 077) * 4 + 2)/3;
      if (*ibuf == 'M' && (len+SHORTALOWANCE) >= ulen && uuCheck(ibuf+1,ulen <= len ? ulen : len)) {
        /* Found an 'M' line - previous line must be garbage */
        if (len < ulen) {               /* we have a slightly short line */
          //fprintf(stderr,"uudecode: warning, short line\n");
          while(len < ulen)
            ibuf[++len] = ' ';
        }
        nib = uuExplodeLine(ibuf,obuf);
        zf->uustate = UUBODY;
        return nib;
      }
      if ((*ibuf != ' ' && *ibuf != '`' ) || (len != 0 && len != 1)) {
        /* Not found correct thing after short line. Assume garbage */
        nib = 0;
        zf->uustate = UUSKIP;
        continue;
      }
    }

    /* Check for an end line */
    if (fgets((char *)ibuf, UULEN, zf->stream) == NULL) {
      //fprintf(stderr,"uudecode: unexpected EOF\n");
      zf->uustate = UUEOF;
      return nib;
    }
    len = strlen((char *)ibuf)-2;
    ulen = ((int)(((*ibuf) - ' ') & 077) * 4 + 2)/3;
    if (*ibuf == 'M' && (len+SHORTALOWANCE) >= ulen && uuCheck(ibuf+1,ulen <= len ? ulen : len)) {
      /* Found an 'M' line - previous lines must be garbage */
      if (len < ulen) {         /* we have a slightly short line */
        //fprintf(stderr,"uudecode: warning, short line\n");
        while(len < ulen)
          ibuf[++len] = ' ';
      }
      nib = uuExplodeLine(ibuf,obuf);
      zf->uustate = UUBODY;
      return nib;
    }
    if (len != 2 || strncmp((char *)ibuf,"end",3)) {
      /* Not found correct thing after short line. Assume garbage */
      nib = 0;
      zf->uustate = UUSKIP;
      continue;
    }
    /* Found end line, assume short line was ok */
    zf->uustate = UUEOF;
    return nib;
  }
}

#define DEC(C)  ((unsigned)(((C) - ' ') & 077))

int
uuExplodeLine(icp,ocp)
Byte *icp;
Byte *ocp;
{
  unsigned int x,y,z;
  int i,len;
  i = len = DEC(*icp);
  ++icp;

  while (i > 0) {
    if (i >= 3) {
      x  = (DEC(*icp) << 2); icp++;
      x |= (DEC(*icp) >> 4);
      y  = (DEC(*icp) << 4); icp++;
      y |= (DEC(*icp) >> 2);
      z  = (DEC(*icp) << 6); icp++;
      z |= (DEC(*icp));
      *ocp++ = x;
      *ocp++ = y;
      *ocp++ = z;
    } else if (i >= 2) {
      x  = (DEC(*icp) << 2); icp++;
      x |= (DEC(*icp) >> 4);
      y  = (DEC(*icp) << 4); icp++;
      y |= (DEC(*icp) >> 2);
      *ocp++ = x;
      *ocp++ = y;
    } else if (i >= 1) {
      x  = (DEC(*icp) << 2); icp++;
      x |= (DEC(*icp) >> 4);
      *ocp++ = x;
    }
    icp++;
    i -= 3;
  }
  return len;
}

/* Check for valid uu encoding characters */
boolean
uuCheck(icp,len)
Byte *icp;
int len;
{
  for(; len > 0;len--,icp++)
    if (*icp >= 'a' || *icp < ' ')
      return FALSE;
  return TRUE;
}




/* JFIF defines the gamma of pictures to be 1.0. */
/* Unfortunately no-one takes any notice (sigh), */
/* and the majority of images are like gifs - they */
/* are adjusted to look ok on a "typical" monitor */
/* using a gamma naive viewer/windowing system. */
/* We give in to the inevitable here and use 2.2 */
#define RETURN_GAMMA 2.2        /* Request JPEG load with gamma of 2.2 */

static ZFILE * input_file;      /* tells input routine where to read JPEG */
struct Decompress_info_struct gcinfo;

/* Error-catching routines */

static char *filename;
static unsigned int verbose;
static unsigned int identify;
static jmp_buf setjmp_buffer;   /* for return to caller */
static external_methods_ptr emethods; /* needed for access to message_parm */

static void
trace_message (msgtext)
     char *msgtext;
{
  //fprintf(stderr, "jpegLoad: %s - ", filename);
  //fprintf(stderr, msgtext,
  //      emethods->message_parm[0], emethods->message_parm[1],
  //      emethods->message_parm[2], emethods->message_parm[3],
  //      emethods->message_parm[4], emethods->message_parm[5],
  //      emethods->message_parm[6], emethods->message_parm[7]);
  //fprintf(stderr, "\n");        /* there is no \n in the format string! */
}

static void
error_exit (msgtext)
     char *msgtext;
{
  trace_message(msgtext);       /* report the error message */
  //zunread(input_file,gcinfo.next_input_byte,gcinfo.bytes_in_buffer);
  (*emethods->free_all) ();     /* clean up memory allocation & temp files */
  longjmp(setjmp_buffer, 1);    /* return control to outer routine */
}


/* Output-acceptance routines */

//static Image *image;            /* xli image being returned */
static int rows_put;            /* Number of rows copied to image */

static void
output_init (cinfo)
     decompress_info_ptr cinfo;
/* Initialize for output */
{

/*
  int i;
  if (cinfo->out_color_space == CS_GRAYSCALE) {
    image = newRGBImage(cinfo->image_width,cinfo->image_height,8);
    image->title = dupString(filename);
    // set a linear map
    for(i=0;i<256;i++) {
      *(image->rgb.red + i) =
        *(image->rgb.green + i) =
          *(image->rgb.blue + i) = i<<8;
    }
    image->rgb.used = 256;
  } else
*/

  if (cinfo->out_color_space == CS_RGB) {
//    image = newTrueImage(cinfo->image_width,cinfo->image_height);
     set_color_depth(32);
     ixres=cinfo->image_width;
     iyres=cinfo->image_height;
     bm=create_bitmap(ixres,iyres);
     clear(bm);
     if (ixres<=320) {xres=320;yres=200;}
        else {
        if (ixres<=640) {xres=640;yres=480;}
           else {
           if (ixres<=800) {xres=800;yres=600;}
           }
        }
//     image->title = dupString(filename);
  } else {
    //image = NULL;
    ERREXIT(cinfo->emethods, "Can't cope with JPEG image colorspace");
  }
  rows_put = 0;
}

static void
put_color_map (cinfo, num_colors, colormap)
     decompress_info_ptr cinfo;
     int num_colors;
     JSAMPARRAY colormap;
/* Write the color map -- should not be called */
{
  //fprintf(stderr, "put_color_map called: there's a bug here somewhere!\n");
}


static void
put_pixel_rows (cinfo, num_rows, pixel_data)
     decompress_info_ptr cinfo;
     int num_rows;
     JSAMPIMAGE pixel_data;
/* Write some rows of output data */
{
  register unsigned char *bufp;
  register JSAMPROW ptr0, ptr1, ptr2;
  register long col;
  long width = cinfo->image_width;
  int row;

  bufp = bm->dat + rows_put * width * 4;
  for (row = 0; row < num_rows; row++) {
    ptr0 = pixel_data[0][row];
    ptr1 = pixel_data[1][row];
    ptr2 = pixel_data[2][row];
    for (col = width; col > 0; col--) {
      *bufp++ = *ptr2++;
      *bufp++ = *ptr1++;
      *bufp++ = *ptr0++;
      bufp++;
    }
  }

  rows_put += num_rows;
}


static void
output_term (cinfo)
     decompress_info_ptr cinfo;
/* Finish up at the end of the output */
{
  zunread(input_file,cinfo->next_input_byte,cinfo->bytes_in_buffer);
}


/* Input-file-reading routine */

static int
read_jpeg_data (cinfo)
     decompress_info_ptr cinfo;
{
  cinfo->next_input_byte = cinfo->input_buffer + MIN_UNGET;

  cinfo->bytes_in_buffer = zread(input_file,
                                 cinfo->next_input_byte,
                                 JPEG_BUF_SIZE);

  if (cinfo->bytes_in_buffer <= 0) {
    WARNMS(cinfo->emethods, "Premature EOF in JPEG file");
    (*emethods->free_all) ();   /* clean up memory allocation & temp files */
    longjmp(setjmp_buffer, 1);  /* return control to outer routine */
  }

  return JGETC(cinfo);
}


/*  Required control-hook routine */


static void
d_ui_method_selection (cinfo)
     decompress_info_ptr cinfo;
{
  /* if grayscale input, force grayscale output; */
  /* else leave the output colorspace as set by main routine. */
  if (cinfo->jpeg_color_space == CS_GRAYSCALE)
    cinfo->out_color_space = CS_GRAYSCALE;

  /* Create display of image parameters */
  if (verbose) {
    //printf("%s is a %dx%d JPEG image, color space ", filename,
      //     cinfo->image_width, cinfo->image_height);
    switch (cinfo->jpeg_color_space) {
    case CS_UNKNOWN:
      printf("Unknown");
      break;
    case CS_GRAYSCALE:
      printf("Grayscale");
      break;
    case CS_RGB:
      printf("RGB");
      break;
    case CS_YCbCr:
      printf("YCbCr");
      break;
    case CS_YIQ:
      printf("YIQ");
      break;
    case CS_CMYK:
      printf("CMYK");
      break;
    }
    printf(", %d comp%s,", cinfo->num_components,
           cinfo->num_components ? "s." : ".");
    if (cinfo->arith_code)
      printf(" Arithmetic coding\n");
    else
      printf(" Huffman coding\n");
  }

  /* Turn off caching beyond this point of the file */
  znocache(input_file);

  /* If we only wanted to identify the image, abort now */
  if (identify) {
    (*emethods->free_all) ();   /* clean up memory allocation & temp files */
    longjmp(setjmp_buffer, 10); /* return control with success code */
  }

  /* select output routines */
  cinfo->methods->output_init = output_init;
  cinfo->methods->put_color_map = put_color_map;
  cinfo->methods->put_pixel_rows = put_pixel_rows;
  cinfo->methods->output_term = output_term;
}

/* Main control routine for loading */

int jpegLoad (fullname/*,image_ops, vbose*/)
     char *fullname;
/*     ImageOptions *image_ops;
     unsigned int vbose;*/
{
//  char  *name = image_ops->name;
  struct Decompress_methods_struct dc_methods;
  struct External_methods_struct e_methods;
  int ljrt;

//  CURRFUNC("jpegLoad");
  input_file = zopen(fullname); /* Open the input file */
  if (input_file == NULL)
    return 0;

  /* Quick check to see if file starts with JPEG SOI marker */
  if (zgetc(input_file) != 0xFF || zgetc(input_file) != 0xD8) {
    zclose(input_file);
    return 0;
  }
  zrewind(input_file);

  filename = fullname;              /* copy parms to static vars */
  verbose = FALSE;
  identify = 0;

  //image = NULL;                 /* in case we fail before creating image */

  gcinfo.methods = &dc_methods; /* links to method structs */
  gcinfo.emethods = &e_methods;
  emethods = &e_methods;        /* save struct addr for possible access */
  e_methods.error_exit = error_exit; /* supply error-exit routine */
  e_methods.trace_message = trace_message; /* supply trace-message routine */
  e_methods.trace_level = 0;    /* default = no tracing */
  e_methods.num_warnings = 0;   /* no warnings emitted yet */
  e_methods.first_warning_level = 0; /* display first corrupt-data warning */
  e_methods.more_warning_level = 3; /* but suppress additional ones */

  /* prepare setjmp context for possible exit from error_exit */
  ljrt = setjmp(setjmp_buffer);
  if (ljrt != 0) {
    /* If we get here, the JPEG code has signaled an error. */
    zclose(input_file);
    if (ljrt != 2 && rows_put > 0) { /* Return as much of the image as we could get. */
      /* Attempt to read trailing opts - mightn't work if jpeg has sucked all of file */
//      read_trail_opt(image_ops,input_file,image,verbose);
      //image->gamma = RETURN_GAMMA;
      //freeImage(image);
      return 0;
    }
    else {      /* No data loaded into image, or not JPEG error */
      //if (image)
       // freeImage(image);
      return 0;
    }
  }

  jselmemmgr(&e_methods);       /* select std memory allocation routines */

  /* Set up default decompression parameters. */
  j_d_defaults(&gcinfo, TRUE);
  gcinfo.output_gamma = RETURN_GAMMA;

  /* Override default methods */
  dc_methods.d_ui_method_selection = d_ui_method_selection;
  dc_methods.read_jpeg_data = read_jpeg_data;

  /* Set up to read a JFIF or baseline-JPEG file. */
  /* This is the only JPEG file format currently supported. */
  jselrjfif(&gcinfo);

  /* Here we go! */

  jpeg_decompress(&gcinfo);

///  read_trail_opt(image_ops,input_file,image,verbose);
  zclose(input_file);           /* Done, close the input file */

//  image->gamma = RETURN_GAMMA;

//  freeImage (image);

  return 1;
}

/* Main control routine for identifying JPEG without loading */


int
jpegIdent (fullname, name)
     char *fullname, *name;
{
  struct Decompress_methods_struct dc_methods;
  struct External_methods_struct e_methods;

//  CURRFUNC("jpegIdent");
  input_file = zopen(fullname); /* Open the input file */
  if (input_file == NULL)
    return 0;

  /* Quick check to see if file starts with JPEG SOI marker */
  if (zgetc(input_file) != 0xFF || zgetc(input_file) != 0xD8) {
    zclose(input_file);
    return 0;
  }
  zrewind(input_file);

  /* We want to find and display the image dimensions, and also
   * verify that the header markers are not corrupt.  To do this,
   * we fire up the JPEG decoder as normal, but when d_ui_method_selection
   * is called, we abort the process by longjmp'ing back here.
   * This works nicely since the headers are all read at that point.
   */

  filename = name;              /* copy parms to static vars */
  verbose = 1;
  identify = 1;

  gcinfo.methods = &dc_methods; /* links to method structs */
  gcinfo.emethods = &e_methods;
  emethods = &e_methods;        /* save struct addr for possible access */
  e_methods.error_exit = error_exit; /* supply error-exit routine */
  e_methods.trace_message = trace_message; /* supply trace-message routine */
  e_methods.trace_level = 0;    /* default = no tracing */
  e_methods.num_warnings = 0;   /* no warnings emitted yet */
  e_methods.first_warning_level = 0; /* display first corrupt-data warning */
  e_methods.more_warning_level = 3; /* but suppress additional ones */

  /* prepare setjmp context for expected exit via longjmp */
  switch (setjmp(setjmp_buffer)) {
  case 0:
    /* First time thru, keep going */
    break;
  case 10:
    /* Successful exit from d_ui_method_selection; return A-OK */
    zclose(input_file);
    return 1;
  default:
    /* If we get here, the JPEG code has signaled an error. */
    /* Return 0 since error in the headers means the image is unloadable. */
    zclose(input_file);
    return 0;
  }

  jselmemmgr(&e_methods);       /* select std memory allocation routines */

  /* Set up default decompression parameters. */
  j_d_defaults(&gcinfo, TRUE);

  /* Override default methods */
  dc_methods.d_ui_method_selection = d_ui_method_selection;
  dc_methods.read_jpeg_data = read_jpeg_data;

  /* Set up to read a JFIF or baseline-JPEG file. */
  /* This is the only JPEG file format currently supported. */
  jselrjfif(&gcinfo);

  /* Here we go! */

  jpeg_decompress(&gcinfo);

  /* Don't expect to get here since d_ui_method_selection should do longjmp */

  zclose(input_file);
  return 0;
}

typedef struct {unsigned char r,g,b;} color;
static color _pal[256],_pal2[256];

static void j_fade_in()
{
 int i,j;
 memset(_pal2,0,768);
 set_pal((byte *)_pal2);
 for (j=0;j<=31;j++) {
     for (i=0;i<=255;i++) {
         if (_pal2[i].r+2 <= _pal[i].r) _pal2[i].r+=2; else _pal2[i].r=_pal[i].r;
         if (_pal2[i].g+2 <= _pal[i].g) _pal2[i].g+=2; else _pal2[i].g=_pal[i].g;
         if (_pal2[i].b+2 <= _pal[i].b) _pal2[i].b+=2; else _pal2[i].b=_pal[i].b;
         }
     sync_wait();
     set_pal((byte *)_pal2);
     }
 set_pal((byte *)_pal);
}

static void j_fade_out()
{
 int i,j;
 memcpy(_pal2,_pal,768);
 for (j=0;j<=31;j++) {
     for (i=0;i<=255;i++) {
         if (_pal2[i].r-2 >= 0) _pal2[i].r-=2; else _pal2[i].r=0;
         if (_pal2[i].g-2 >= 0) _pal2[i].g-=2; else _pal2[i].g=0;
         if (_pal2[i].b-2 >= 0) _pal2[i].b-=2; else _pal2[i].b=0;
         }
     sync_wait();
     set_pal((byte *)_pal2);
     }
}

extern int gop(BITMAP *image, PALETTE pal, char rsvdcols[256]);

int show_jpg(char *jpg_name)
{
FILE *f;
//ImageOptions iopt;
int i,error=0,pal_mode=0;
PALLETE pal;
char b[256];

if ((f=fopen(jpg_name,"rb"))==NULL) {
    jpg_position=atol(jpg_name)+pictures_offset;
    file_name=data_name;
    } else {
    fclose(f);
    jpg_position=0;
    file_name=jpg_name;
    }

//vmode(3);
//hide_cursor();

//INIT_IMAGE_OPTS(iopt);
//iopt.name=file_name;

if (jpegLoad(file_name/*,&iopt,FALSE*/)) {
   change_sync_rate(yres);
   set_color_depth(32);
   if (set_gfx_mode(GFX_AUTODETECT, xres, yres, 0, 0)) {
      set_color_depth(24);
      if (set_gfx_mode(GFX_AUTODETECT, xres, yres, 0, 0)) {
         set_color_depth(16);
         if (set_gfx_mode(GFX_AUTODETECT, xres, yres, 0, 0)) {
            set_color_depth(15);
            if (set_gfx_mode(GFX_AUTODETECT, xres, yres, 0, 0)) {
               set_color_depth(8);
               if (set_gfx_mode(GFX_AUTODETECT, xres, yres, 0, 0)) {
               error=1;
               } else pal_mode=1;
            }
         }
      }
   }
   if (!error) {

      clear(screen);

      if (pal_mode) {
         rgb_map=malloc(sizeof(RGB_MAP));
         memset(b,0,256);b[0]=1;gop(bm,pal,b);
         pal[0].r=0;pal[0].g=0;pal[0].b=0;
         //set_pallete(pal);
         create_rgb_table(rgb_map,pal,NULL);
         memset(_pal2,0,768);
         set_pal((byte *)_pal2);
         for (i=0;i<256;i++) {
             _pal[i].r=pal[i].r;
             _pal[i].g=pal[i].g;
             _pal[i].b=pal[i].b;
             }
         }

      blit(bm,screen,0,0,(xres-ixres)/2,(yres-iyres)/2,ixres,iyres);

      if (pal_mode) j_fade_in();

      while (!key[KEY_ESC] && !(key[KEY_CONTROL] &&
            key[KEY_LEFT]) && !right_pressed) v_read_mouse();

      if (pal_mode) {
         j_fade_out();
         free(rgb_map);
         }
      }

   } else error=1;


clear(screen);
destroy_bitmap(bm);
set_color_depth(8);
//set_gfx_mode(GFX_TEXT,80,25,0,0);
change_sync_rate(mode_stdvga ? 400 : 480);
while (right_pressed) v_read_mouse();
return -error;
}
