
//         Ŀ
//          Tools & Music support for DJGPP version of diskmag Vyhen 
//                     code: ReDox/MovSD & HH/AA (C) 1997            
//         

#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <string.h>
#include <conio.h>
#include <math.h>
#include <dpmi.h>
#include <dos.h>
#include <dir.h>
#include <pc.h>
#include <go32.h>
#include <sys/farptr.h>
#ifdef __FULL__
#include <midasdll.h>
#include <allegro.h>
#endif

#include "vyhen.h"

unsigned refreshRate400, refreshRate480, refreshRate600;
char module_name_array[MAX_MODULE][MAXPATH],last_module=-1;
byte s_buffer[4000];

static int bk_mouse;
unsigned last_position;

int left_pressed, right_pressed, center_pressed, mouse_x, mouse_y,
    o_mouse_x, o_mouse_y, o_scroll_line, scroll_line;

volatile byte red=80, mouse_s=HIDDEN;
volatile char i_red=1, micro_line;
volatile int scroll_line, last_line, s_y, frameCount, mode_stdvga,
             set_start_addr, button_blink, old_frameCount,
             mode_monochrome, do_not_show_mouse=0;

#ifdef __FULL__
MIDASmodule module;
#endif

inline void vmode(char c)
{
  __dpmi_regs r;

  r.h.ah        = 0x00;
  r.h.al        = c;
  __dpmi_int (0x10, &r);
}

#ifdef __FULL__
void MIDAS_CALL prevr(void)
{

 int y_addr;

 frameCount++;

 if (hardware_scrolling_enabled) {


 if (set_start_addr) {
 /*
    disable();
    if (!((inportb(0x3da))&8)) {*/
    y_addr=scroll_line*80;
    outpw(0x3d4,12+((y_addr>>8)<<8));
    outpw(0x3d4,13+((y_addr-((y_addr>>8)<<8))<<8));
    set_start_addr=0;
 /*
    enable();
    } else
    { enable();
      return;
    }*/
    }
 outpw(0x3d4,8+(micro_line<<8));
 }

}
#endif

#ifdef __FULL__
void MIDAS_CALL postvr(void)
#else
void postvr(void)
#endif
{

 if (red==160) i_red=-1;
 if (red==80) i_red=1;
 if (i_red==1) red++; else red--;

 if (button_blink) {
    outportb(0x3c8,5);
    if (mode_monochrome) {
       outportb(0x3c9,0);
       outportb(0x3c9,red/4);
       } else {
       outportb(0x3c9,red/4);
       outportb(0x3c9,0);
       }
    outportb(0x3c9,0);
    }

}

#ifdef __FULL__
void MIDAS_Error(void)
{
 printf("MIDAS error: %s\n", MIDASgetErrorMessage(MIDASgetLastError()));
 MIDASclose(); /*!!!!!*/
 exit(EXIT_FAILURE);
}
#endif


void MIDAS_Init(char *module_name, int manual_config)
{

#ifdef __FULL__

    int i,j;
    FILE *cfg_f;
    char config_name[MAXPATH], d[MAXDRIVE],
         p[MAXDIR], e[MAXEXT], s[MAXPATH];

    MIDASstartup();

    fnsplit(exe_name,d,p,NULL,NULL);
    fnmerge(config_name,d,p,"vyhen",".cfg");

    if (exists(config_name) && !manual_config) {

       MIDASloadConfig(config_name);
       cfg_f=fopen(config_name,"rb");
       fseek(cfg_f,-sizeof(unsigned)*3,SEEK_END);
       fread(&refreshRate400,sizeof(unsigned),1,cfg_f);
       fread(&refreshRate480,sizeof(unsigned),1,cfg_f);
       fread(&refreshRate600,sizeof(unsigned),1,cfg_f);
       fclose(cfg_f);

       } else {

       printf("  Konfigurace MiDASe\n");

       i=wherex();
       j=wherey();

       dosmemput(s_buffer,4000,SEG_B800);

//       if (!manual_config)
//          manual_config=!MIDASdetectSoundCard();

//       if (manual_config)

       if (!MIDASconfig())
          if (MIDASgetLastError()) MIDAS_Error();

       vmode(3);
       dosmemget(SEG_B800,4000,s_buffer);
       gotoxy(i,j);

       puts("  Synchronizace s paprskem");

       i=wherex();
       j=wherey();

       dosmemput(s_buffer,4000,SEG_B800);

       vmode(3);

       refreshRate400 = MIDASgetDisplayRefreshRate();

       set_mode_80x30();
       refreshRate480 = MIDASgetDisplayRefreshRate();

       set_gfx_mode(GFX_AUTODETECT,800,600,0,0);
       refreshRate600 = MIDASgetDisplayRefreshRate();

       vmode(3);

       dosmemget(SEG_B800,4000,s_buffer);

       gotoxy(i,j);

       if ( refreshRate400 == 0 || refreshRate480 == 0 || refreshRate600 ==0 )
       {

        printf("  Chyba: Nemuzu  zjistit obnovovaci frekvenci videokarty!\n"
               "          Asi poustis Vyhen z Win95/NT nebo zrovna uklada\n"
               "          diskova cache velkej objem dat na disk. Stiskni\n"
               "          cokoli  pro  pokracovni  s tim, ze scrolling se\n"
               "          bude   zrejme   trhat  a  muzou  se  vyskytnout\n"
               "          problemy pri nastavovani palety. Jinak <ESC>.\n");

           if (getch()==27) exit(0);

           refreshRate400 = 70000;
           refreshRate480 = 60000;
           refreshRate600 = 50000;
       }

       printf("  400:%d, 480:%d, 600:%d\n",
              refreshRate400,refreshRate480,refreshRate600);

       printf("  Ukladam stavajici konfiguraci do souboru vyhen.cfg\n");

       MIDASsaveConfig(config_name);
       cfg_f=fopen(config_name,"ab");
       fwrite(&refreshRate400,sizeof(unsigned),1,cfg_f);
       fwrite(&refreshRate480,sizeof(unsigned),1,cfg_f);
       fwrite(&refreshRate600,sizeof(unsigned),1,cfg_f);
       fclose(cfg_f);

       }

    fnsplit(module_name,NULL,NULL,NULL,e);

    if (strcmp(e,".lst")==0) {

       if ((cfg_f=fopen(module_name,"r"))==NULL) {
          printf("\n  Chyba #08: Seznam modulu %s nenalezen !\n",
          module_name);
          exit(0);
          }

       i=0;

       while (fgets(s,MAXPATH,cfg_f)!=NULL) {
             memset(module_name_array[i],0,MAXPATH);
             if (s[strlen(s)-1]=='\n')
                j=strlen(s)-1; else j=strlen(s);
             strncpy(module_name_array[i],s,j);
             fnsplit(module_name_array[i],NULL,NULL,NULL,e);
             if (exists(module_name_array[i])) {
                if (strstr(e,".xm")  !=NULL ||
                    strstr(e,".mod") !=NULL ||
                    strstr(e,".s3m") !=NULL ) i++;
                    else printf("  Chyba #09: Soubor %s neni podporvany modul !\n",
                         module_name_array[i]);
                } else printf("  Chyba #10: Modul %s nenalezen !\n",
                       module_name_array[i]);
             if (i>10) break;
             }

       last_module=i-1;

       if (last_module>=0) {
          printf("  Seznam modulu:\n");
          for (i=0;i<=last_module;i++)
              printf(" F%d -> %s\n",i+1,module_name_array[i]);
          } else {
            printf("\n  Chyba #11: Seznam %s neobsahuje zadny modul !\n",
            module_name);
            exit(0);
            }

       } else {

       if (strlen(module_name)>0) {

       if (!exists(module_name)) {
          printf("  Chyba #10: Modul %s nenalezen !\n",module_name);
          exit(0);
          }

        strcpy(module_name_array[0],module_name);
        last_module=0;

        } else last_module=-1;
       }

    puts("  Inicializuji MIDAS Sound System");

    if (!MIDASinit()) MIDAS_Error();

    if (last_module>=0)
       printf("  Nahravam modul: %s\n",module_name_array[0]);

    module=NULL;

    if (last_module>=0) {
       if ((module=MIDASloadModule(module_name_array[0]))==NULL)
          MIDAS_Error();
       module_num=0;
       }
    if (!MIDASsetTimerCallbacks(
       mode_stdvga ? refreshRate400 : refreshRate480,1,&prevr,NULL,&postvr))
       MIDAS_Error();
    last_position=0;
    if (module!=NULL)
       if (!MIDASplayModule(module,0))
          MIDAS_Error();

#endif

}

void MIDAS_Done()
{

#ifdef __FULL__

 if (module!=NULL) {
    if (!MIDASstopModule(module)) MIDAS_Error();
    if (!MIDASfreeModule(module)) MIDAS_Error();
    }

 if (!MIDASremoveTimerCallbacks()) MIDAS_Error();
 if (!MIDASclose()) MIDAS_Error();

#endif

}



int test_module()
{

#ifdef __FULL__

 static MIDASplayStatus status;
 if (!MIDASgetPlayStatus(&status)) MIDAS_Error();

 if (status.position<last_position) return 1; else
    { last_position = status.position; return 0; }

#else

 return 0;

#endif

}

void switch_module(byte id)
{

#ifdef __FULL__

 if (id<=last_module || id==STOP_MUSIC) {

    if (id!=STOP_MUSIC) module_num=id; else module_num=-1;

    if (module!=NULL) {
       if (!MIDASstopModule(module)) MIDAS_Error();
       if (!MIDASfreeModule(module)) MIDAS_Error();
       }

    module=NULL;

    if (!MIDASremoveTimerCallbacks()) MIDAS_Error();

    if (!MIDASclose()) MIDAS_Error();
    if (!MIDASinit()) MIDAS_Error();

    if (id!=STOP_MUSIC)
    if ((module=MIDASloadModule(module_name_array[id]))==NULL) MIDAS_Error();

    if (!MIDASsetTimerCallbacks(
       mode_stdvga ? refreshRate400 : refreshRate480,1,&prevr,NULL,&postvr))
       MIDAS_Error();

    last_position=0;
    if (module!=NULL && id!=STOP_MUSIC)
       if (!MIDASplayModule(module,0)) MIDAS_Error();

    }

#endif

}

void button_blinking()
{

 while ((inportb(0x3da))&8);
 while (!((inportb(0x3da))&8));
 postvr();

}

void sync_wait()
{

 int y_addr;

 if (mode_stdmode) {

  if (hardware_scrolling_enabled) {

     do { } while (!(inportb(0x3DA) & 8));
     do { } while (inportb(0x3DA) & 1);

     if (set_start_addr) {
        disable();
        if (!((inportb(0x3da))&8)) {
           y_addr=scroll_line*80;
           outpw(0x3d4,12+((y_addr>>8)<<8));
           outpw(0x3d4,13+((y_addr-((y_addr>>8)<<8))<<8));
           set_start_addr=0;
           outpw(0x3d4,8+(micro_line<<8));
           }
        enable();
        } else outpw(0x3d4,8+(micro_line<<8));

     } else {
       while ((inportb(0x3da))&8);
       while (!((inportb(0x3da))&8));
       }

 postvr();

 } else {

 old_frameCount = frameCount;
 while (old_frameCount == frameCount);

 }

}

#ifdef __FULL__
void change_sync_rate(int micro_lines)
{
 int rate;
 if (!mode_stdmode) {
 if (micro_lines==480 || micro_lines==240)
    rate=refreshRate480; else
    if (micro_lines==600) rate=refreshRate600;
    else rate=refreshRate400;
 if (!MIDASremoveTimerCallbacks()) MIDAS_Error();
 if (!MIDASsetTimerCallbacks(rate,1,&prevr,NULL,&postvr)) MIDAS_Error();
 }
}
#endif

void v_set_font(byte *font)
{
  int i;

  outportw(0x3C4,0x0402);
  outportw(0x3C4,0x0704);
  outportw(0x3CE,0x0204);
  outportw(0x3CE,0x0005);
  outportw(0x3CE,0x0006);

  for (i=0;i<256;i++)
      dosmemput(font+i*16,16,0xA0000+i*32);

  outportw(0x3C4,0x0302);
  outportw(0x3C4,0x0304);
  outportw(0x3CE,0x0004);
  outportw(0x3CE,0x1005);
  outportw(0x3CE,0x0E06);

}

inline void set_rgb(byte c, byte r, byte g, byte b)
{
  outportb(0x3C8,c);
  outportb(0x3C9,r);
  outportb(0x3C9,g);
  outportb(0x3C9,b);
}

inline void get_pal(byte *pal)
{
  int c;

  for (c=0;c<=767;c+=3) {
      outp(0x3C7,c/3);
      *(pal+c+0)=inportb(0x3C9);
      *(pal+c+1)=inportb(0x3C9);
      *(pal+c+2)=inportb(0x3C9);
      }
}

inline void set_pal(byte *pal)
{
  int c;
  byte r,g,b;

  for (c=0;c<=767;c+=3) {
      r=*(pal+c+0);
      g=*(pal+c+1);
      b=*(pal+c+2);
      outportb(0x3C8,c/3);
      outportb(0x3C9,r);
      outportb(0x3C9,g);
      outportb(0x3C9,b);
      }
}

inline void hide_cursor()
{
  __dpmi_regs r;

  r.h.cl        = 0;
  r.h.ch        = 0x20;
  r.h.ah        = 1;
  r.h.al        = 0;
  __dpmi_int (0x10, &r);
}

inline void v_set_mouse(int x, int y)
{
  __dpmi_regs r;

  if (!mode_nomouse) {

  r.x.ax = 4;
  r.x.cx = x*8;
  r.x.dx = y*8;
  __dpmi_int (0x33, &r);

  }

}

inline int v_is_mouse(void)
{
  __dpmi_regs r;

  r.x.ax = 0;
  __dpmi_int (0x33, &r);

 return (r.x.ax!=0);

}

inline void v_read_mouse()
{
  __dpmi_regs r;

  if (!mode_nomouse) {

  r.x.ax = 3;
  __dpmi_int (0x33, &r);

  left_pressed = (r.x.bx & 1)==1;
  right_pressed = (r.x.bx & 2)==2;
  center_pressed = (r.x.bx & 4)==4;
  mouse_x = r.x.cx / 8;
  mouse_y = r.x.dx / 8;

  }

}

inline void v_hide_mouse()
{
 if (!mode_nomouse) {
 if (mouse_s!=HIDDEN) {
    _farpokew(_dos_ds,SEG_B800+o_mouse_x*2+
    (o_mouse_y+o_scroll_line)*S_X*2,bk_mouse);
    mouse_s=HIDDEN;
    }
 }
}

inline void v_show_mouse()
{
 if (!mode_nomouse) {
 v_read_mouse();
 if (mouse_s!=VISIBLE && !do_not_show_mouse) {
 bk_mouse=_farpeekw(_dos_ds, SEG_B800+ (mouse_x*2+(mouse_y+scroll_line)*S_X*2));
 _farpokew(_dos_ds, SEG_B800 + (mouse_x*2+(mouse_y+scroll_line)*S_X*2),MOUSE_COLOR);
 o_mouse_x=mouse_x;
 o_mouse_y=mouse_y;
 o_scroll_line=scroll_line;
 mouse_s=VISIBLE;
 }
 }
}


inline void v_set_mouse_range(int x1, int y1, int x2, int y2)
{
  __dpmi_regs r;

  if (!mode_nomouse) {
  r.x.ax = 7;
  r.x.cx = x1*8;
  r.x.dx = x2*8;
  __dpmi_int (0x33, &r);

  r.x.ax = 8;
  r.x.cx = y1*8;
  r.x.dx = y2*8;
  __dpmi_int (0x33, &r);
  }

}

#ifdef __FULL__
int show_fli(char *fli_name)
{
FILE *f;
long fli_position,fli_size;
short fli_speed,i;
char file_name[128],*fli_data;

//vmode(3);
//hide_cursor();

if ((f=fopen(fli_name,"rb"))==NULL) {
    fli_position=atol(fli_name)+pictures_offset;
    strcpy(file_name,data_name);
    } else {
    fclose(f);
    fli_position=0;
    strcpy(file_name,fli_name);
    }

if ((f=fopen(file_name,"rb"))==NULL) return -1;
fseek(f,fli_position+16,SEEK_SET);
fread(&fli_speed,2,1,f);
fseek(f,fli_position,SEEK_SET);
fread(&fli_size,4,1,f);
fseek(f,fli_position,SEEK_SET);
if ((fli_data=malloc(fli_size))==NULL) { fclose(f); return -1; }
fread(fli_data,fli_size,1,f);
fclose(f);

change_sync_rate(200);
if (set_gfx_mode(GFX_AUTODETECT,320,200,0,0)!=0) return -1;
clear(screen);

open_memory_fli(fli_data);

while (!key[KEY_ESC] &&
       !(key[KEY_CONTROL] && key[KEY_LEFT]) &&
       !right_pressed) {
      for (i=0;i<fli_speed/2;i++) sync_wait();
      v_read_mouse();
      next_fli_frame(TRUE);
      set_palette(fli_palette);
      blit(fli_bitmap,screen,0,0,0,0,320,200);
      }

close_fli();

clear(screen);
//set_gfx_mode(GFX_TEXT,80,25,0,0);
change_sync_rate(mode_stdvga ? 400 : 480);
return 0;
}
#endif