//       Ŀ
//                0% portable GNU-C hypertext engine          
//                                                                  
//                .sS$S           
//                $$$$~!S!$S$'.sSS$Ss.`!$.sSs.           
//                $$$'`$$$.`b.$$$!'`!$b$$$$.           
//                !$!$$b$b..d$!$.sSs..sSSS$!$$           
//                $$!$$$$$!.$$S!^!$.$$$           
//                ?$s.d$$`$$i$$'$$.d',$i$!           
//                `!sdS'SS$d$!S!'.$$.d$!gr        
//                              
//                  by ReDox/MovSD & HH/AA (C) 19-03-1999           
//                                                                  
//       
//                             DJGPPver1.1

#ifndef VYHEN_H
#define VYHEN_H

#include <dir.h>
#include <dpmi.h>

#define VYHEN_LAST_NUM 10
#define VYHEN_LOGO "[ Vyhen #"
#define OLD_VYHEN_LOGO " Vyhen #"
#define LOGO_POSITION 113
#define OLD_LOGO_POSITION 114
#define LZH_CODE_POSITION 8246
#define VEOF 0xffff
#define S_X 80
#define SEG_B800 0xb8000
#define KEYBOARD_INT 9
#define BUTTON_COLOR 5
#define ACTIVE_BUTTON_COLOR 3
#define END_OF_FUNCTION(x) void x##_end() { }
#define LOCK_VARIABLE(x) _go32_dpmi_lock_data((void *)&x, sizeof(x))
#define LOCK_FUNCTION(x) _go32_dpmi_lock_code(x, (long)x##_end - (long)x)
#define PATH_SIZE 128
#define MAX_SPLIT 8
#define MAX_LINE_SIZE 256
#define MAX_LINES 204
#define MAX_BUTTON 40
#define MAX_HISTORY 40
#define MAX_LABEL_LENGTH 80
#define MAX_LABELS 1000
#define MAX_MODULE 10
#define STOP_MUSIC 10
#define KEY_REPEAT -32
#define KEY_NOPRESSED -86
#define MOUSE_COLOR 0x1ffe
#define SCROLL_SPEED 8
#define SPLIT_MENU 8
#define VISIBLE 10
#define HIDDEN  20
#define IS_NUM(x) ((x) >= '0' && (x) <= '9')

typedef unsigned char byte;
typedef int (*ifunptr) ();
typedef struct { char *text;
                 long position; } tlabel;
typedef struct { int y;
                 int x1;
                 int x2;
                 char label[S_X]; } tbutton;
typedef struct { int mouse_x;
                 int mouse_y;
                 int scroll_pos;
                 int scroll_line;
                 int selected_button;
                 char curr_label[MAX_LABEL_LENGTH]; } thistory;

__dpmi_free_mem_info free_memory;

extern long pictures_offset, text_position, text_size;

extern unsigned last_position;

extern byte *text, red, MENU_IMAGE[], FONT_DATA[], BIOS_PAL[],
            (*scroll_buffer)[S_X*2], split_buffer[MAX_SPLIT][S_X*2],
            (*html_scroll_buffer)[S_X*2], vyhen_pack;

extern char micro_line, data_name[PATH_SIZE], exe_name[PATH_SIZE],
            module_name_array[MAX_MODULE][MAXPATH], last_module,
            curr_title[PATH_SIZE], gif_name[PATH_SIZE],
            pics_path[PATH_SIZE], vyh_num[MAXEXT],
            curr_label[MAX_LABEL_LENGTH];

extern int left_pressed, right_pressed, center_pressed, mouse_x, mouse_y,
           o_mouse_x, o_mouse_y, o_scroll_line, scroll_line, last_line,
           keyboard_installed, hardware_scrolling_enabled, set_start_addr,
           button_blink, mode_stdvga, mode_stdmode, mode_monochrome,
           do_not_show_mouse, mode_nomouse, mode_hidemouse, s_size,
           s_y, module_num, last_label, split_active;

extern tbutton button[MAX_BUTTON];
extern thistory history[MAX_HISTORY];
extern tlabel labels[MAX_LABELS];

int gz_create(char *name, long gz_start);
int gz_unpack(char *name, long gz_start);
int lzh_unpack(char *packed_file, long lzh_start);
int my_keyint();
int install_keyboard();
int show_gif(char *gif_name);
int show_jpg(char *jpg_name);
int show_png(char *png_name);
int show_fli(char *fli_name);
int fexists(char *filename);
int v_is_mouse();
int test_module();
int printbuf(byte buff[][S_X*2], int x, int y, int attr, char *format,...);
char *vgets(char *s,int n);
void set_mode_80x30();
void split(int n);
void remove_keyboard();
void vmode(char c);
void hide_cursor();
void set_pal(byte *pal);
void get_pal(byte *pal);
void set_rgb(byte c, byte r, byte g, byte b);
void v_set_mouse(int x, int y);
void v_hide_mouse();
void v_show_mouse();
void v_read_mouse();
void v_set_mouse_range(int x1, int y1, int x2, int y2);
void MIDAS_Init();
void MIDAS_Done();
void change_sync_rate(int micro_lines);
void switch_module(byte id);
void sync_wait();
void button_blinking();
void v_set_font(byte *font);
void draw_per();
void brutal_export();
void create_html();
void detect_ansi();
void create_data_table();
void GIFEncode(char *FName, int GWidth, int GHeight, int GInterlace, int Background, int BitsPerPixel, char *Pal, ifunptr GetPixel);

extern volatile char v_key[128];
int v_install_keyboard();
void v_remove_keyboard();
#define key v_key
#define SPEED_NORMAL 0
#define SPEED_SWAP 1
#define SPEED_PAGE 2
#define SPEED_MAX 3
struct driver
{
  int (*init)(void);
  void (*exit)(void);
  void (*update_buffer)(void);
  void (*update_split)(void);
  void (*display_text)(void);
  void (*hide_text)(void);
  void (*update_mouse)(void);
  void (*set_scrollpos)(int p);
  void (*scroll)(int dirrection, int speed);
  void (*set_splitsize)(int size);
  int scroll_range;
  int scroll_pos;
  int split_size;
  int s_y;
  int s_start;
} hsc_driver,dsc_driver;

extern struct driver *driver;

#endif

// Ŀ
//  PNG-lib header 
// 

#ifdef VYHEN_PNG

#define ERR_ASSERT -1 //Assertion failure or internal error
#define ERR_USAGE -2       //Usage: ptot filename[.png]
#define ERR_MEMORY -3      //Could not allocate memory
#define ERR_READ -4        //Failure reading input file
#define ERR_WRITE -5       //Failure writing output file
#define ERR_BAD_PNG -6     //Input PNG file is incorrect format
#define ERR_BAD_IMAGE -7   //Input image failed consistency check
#define ERR_BYTE_ORDER -8  //Incompatible byte order
#define ERR_NO_IDAT -9     //No image data found
#define ERR_COMP_HDR -10    //Input PNG has invalid compression header
#define ERR_EARLY_EOI -11   //Incomplete IDAT on input
#define ERR_INFLATE -12     //Decompression failure
#define WARN_BAD_CRC -13    //Input PNG file failed CRC check
#define WARN_BAD_SUM -14    //Uncompressed image data failed sum check
#define WARN_BAD_PNG -15    //Invalid (but recoverable) PNG file
#define WARN_EXTRA_BYTES -16 //Extra bytes in PNG file ignored
#define WARN_PLTE_GRAY -17  //Palette appears in grayscale image
#define WARN_LATE_GAMA -18  //Gamma value appears after palette
#define WARN_LATE_TRNS -19  //Transparency chunk appears after palette
#define WARN_NO_PLTE -20    //No palette found for palette-based image
#define WARN_MULTI_PLTE -21 //More than one palette present
#define WARN_MULTI_TRNS -22 //More than one transparency chunk present
#define WARN_FILTER -23     //Unknown prediction filter in input PNG
#define WARN_BAD_VAL -24    //Unknown value in PNG chunk

#define _X86_

#ifdef _X86_            /* Intel i86 family */
#  define LITTLE_ENDIAN
#endif

#ifdef _SPARC_
#  define BIG_ENDIAN
#  ifndef FILENAME_MAX /* Work around stupid header file bugs */
#    define FILENAME_MAX 1024
#  endif
#endif

#ifndef SEEK_SET
#  define SEEK_SET 0
#endif
#ifndef min
#  define min(x,y) (((x)<(y))?(x):(y))
#endif
#ifndef max
#  define max(x,y) (((y)<(x))?(x):(y))
#endif

/*
 * Some types and macros for easier porting. Byte swapping is the
 * major issue because we have to convert big-endiang PNG to
 * native-endian TIFF on whatever architecture we're compiled on.
 * The code depends heavily on the endianness definition above.
 * Functions would be a lot simpler than macros here, but are less
 * likely to be optimized down to simple inline byte swaps. Note
 * that some of these macros evaluate the address twice, so don't
 * pass "*p++" to them!
 */

typedef signed char     S8;
typedef unsigned char   U8;
typedef signed short    S16;
typedef unsigned short  U16;
typedef signed long     S32;
typedef unsigned long   U32;

#ifndef TRUE
#  define TRUE 1
#  define FALSE 0
#endif

#define LOBYTE(w)   ((U8)((w)&0xFF))
#define HIBYTE(w)   ((U8)(((w)>>8)&0xFF))
#define LOWORD(d)   ((U16)((d)&0xFFFF))
#define HIWORD(d)   ((U16)(((d)>>16)&0xFFFF))

#define PUT16(p,w)  (*(U16*)(p)=(w))    /* Native byte order */
#define GET16(p)    (*(U16*)(p))
#define PUT32(p,d)  (*(U32*)(p)=(d))
#define GET32(p)    (*(U32*)(p))

#if !defined(BIG_ENDIAN) && !defined(LITTLE_ENDIAN)
#  error "No byte order defined"
#endif

#ifdef BIG_ENDIAN
#  define BE_GET16(p)     GET16(p)
#  define BE_PUT16(p,w)   PUT16((p),(w))
#  define BE_GET32(p)     GET32(p)
#  define BE_PUT32(p,d)   PUT32((p),(d))
#  define LE_GET16(p)     ((U16)(*(U8*)(p)&0xFF)|(*((U8*)(p)+1)<<8))
#  define LE_PUT16(p,w)   (((*(U8*)(p))=LOBYTE(w)),((*((U8*)(p)+1))=HIBYTE(w)))
#  define LE_GET32(p)     (((U32)LE_GET16(p))|LE_GET16((U8*)(p)+2)<<16)
#  define LE_PUT32(p,d)   (LE_PUT16((p),LOWORD(d)),LE_PUT16((U8*)(p)+2,HIWORD(d)))
#else
#  define BE_GET16(p)     ((U16)(*(U8*)(p)<<8)|(*((U8*)(p)+1)&0xFF))
#  define BE_PUT16(p,w)   (((*(U8*)(p))=HIBYTE(w)),((*((U8*)(p)+1))=LOBYTE(w)))
#  define BE_GET32(p)     (((U32)BE_GET16(p)<<16)|BE_GET16((U8*)(p)+2))
#  define BE_PUT32(p,d)   (BE_PUT16((p),HIWORD(d)),BE_PUT16((U8*)(p)+2,LOWORD(d)))
#  define LE_GET16(p)     GET16(p)
#  define LE_PUT16(p,w)   PUT16((p),(w))
#  define LE_GET32(p)     GET32(p)
#  define LE_PUT32(p,d)   PUT32((p),(d))
#endif

/*
 * Miscellaneous PNG definitions.
 */

#define PNG_Signature       "\x89\x50\x4E\x47\x0D\x0A\x1A\x0A"
#define PNG_MaxChunkLength  0x7FFFFFFFL

#define PNG_CN_IHDR 0x49484452L     /* Chunk names */
#define PNG_CN_PLTE 0x504C5445L
#define PNG_CN_IDAT 0x49444154L
#define PNG_CN_IEND 0x49454E44L
#define PNG_CN_gAMA 0x67414D41L
#define PNG_CN_sBIT 0x73424954L
#define PNG_CN_cHRM 0x6348524DL
#define PNG_CN_tRNS 0x74524E53L
#define PNG_CN_bKGD 0x624B4744L
#define PNG_CN_hIST 0x68495354L
#define PNG_CN_tEXt 0x74455874L
#define PNG_CN_zTXt 0x7A545874L
#define PNG_CN_pHYs 0x70485973L
#define PNG_CN_oFFs 0x6F464673L
#define PNG_CN_tIME 0x74494D45L
#define PNG_CN_sCAL 0x7343414CL

#define PNG_CF_Ancillary    0x20000000L /* Chunk flags */
#define PNG_CF_Private      0x00200000L
#define PNG_CF_CopySafe     0x00000020L

#define PNG_FT_Adaptive 0   /* Filtering type */
#define PNG_CT_Deflate  0   /* Compression type */
#define PNG_IT_None     0   /* Interlace types */
#define PNG_IT_Costello 1

#define PNG_CB_Palette  0x01    /* Colortype bits */
#define PNG_CB_Color    0x02
#define PNG_CB_Alpha    0x04

#define PNG_MU_None         0   /* Measurement units */
#define PNG_MU_Pixel        0
#define PNG_MU_Meter        1
#define PNG_MU_Micrometer   1
#define PNG_MU_Radian       2

#define PNG_PF_None     0   /* Prediction filters */
#define PNG_PF_Sub      1
#define PNG_PF_Up       2
#define PNG_PF_Average  3
#define PNG_PF_Paeth    4

/*
 * Structure for holding miscellaneous image information. The
 * conversion program will read an image into this structure, then
 * pass it to the output function. In this implementation, the
 * image data bytes are stored in a file, which is pointed to by
 * this structure. This is so the code will work on small-memory
 * architectures like MS-DOS. On Unix, Win32 (NT/Chicago), and other
 * systems, it might make more sense to simply allocate one big
 * chunk of memory for the image and replace the image_data_file
 * string with an image_data_buffer pointer.
 */

#define N_KEYWORDS 5

typedef struct _image_info {
    U32 width, height;
    U32 xoffset, yoffset;
    U32 xres, yres;
    double xscale, yscale;
    double source_gamma;
    U32 chromaticities[8];      /* Fixed point x 100000 */
    int resolution_unit;        /* Units as in PNG */
    int offset_unit, scale_unit;
    int samples_per_pixel;
    int bits_per_sample;
    int significant_bits[4];
    int background_color[4];
    int is_color, has_alpha, has_trns;
    int is_interlaced, is_palette;
    int palette_size;
    U8 palette[3 * 256];
    U16 trans_values[3];
    U8 palette_trans_bytes[256];
    char *keywords[N_KEYWORDS];
    char *pixel_data;
//    char *pixel_data_file;      /* Where to find the pixels */
    U32 png_data_size;
    char *png_data_file;    /* Untranslatable PNG chunks */
} IMG_INFO;

#define IMG_SIZE (sizeof (struct _image_info))

extern char *keyword_table[N_KEYWORDS];
extern U16 ASCII_tags[N_KEYWORDS];

/*
 * Local ASSERT macro.  Assumes the function Assert() is
 * defined somewhere in the calling program (in this case,
 * it's in ptot.c).
 */

//#ifndef NDEBUG
//#  define ASSERT(x) ((x)?(void)0:Assert(__FILE__,__LINE__))
//#  define TRACE_STR(x) (fprintf(stderr,"TR: %s\n",(x)),fflush(stderr))
//#  define TRACE_INT(x) (fprintf(stderr,"TR: %ld\n",(long)(x)),fflush(stderr))
//#else
#  define ASSERT(x) ;
#  define TRACE_STR(x) ;
#  define TRACE_INT(x) ;
//#endif

/*
 * Prototypes
 */

U32 update_crc(U32, U8 *, U32);

//int main(int argc, char *argv[]);
void print_warning(int);
void error_exit(int);
void Assert(char *, int);
int read_PNG(FILE *, IMG_INFO *);
int get_chunk_header(void);
U32 get_chunk_data(U32);
int verify_chunk_crc(void);

int decode_IDAT(void);
U8 fill_buf(void);
void flush_window(U32);
int decode_text(void);
int copy_unknown_chunk_data(void);
size_t new_line_size(IMG_INFO *, int, int);

int get_local_byte_order(void);
int write_TIFF(FILE *, IMG_INFO *);

int create_tempfile(int);
int open_tempfile(int);
void close_all_tempfiles(void);
void remove_all_tempfiles(void);

/*
 * Interface to Mark Adler's inflate.c
 */

int PNG_inflate(void);

typedef unsigned char uch;
typedef unsigned short ush;
typedef unsigned long ulg;
typedef void *voidp;

#define slide (ps.inflate_window)
#define WSIZE ((size_t)(ps.inflate_window_size))
#define NEXTBYTE ((--ps.bytes_in_buf>=0)?(*ps.bufp++):fill_buf())
#define FLUSH(n) flush_window(n)
#define memzero(a,s) memset((a),0,(s))
#define qflag 1

/*
 * A state structure is used to store all needed info about
 * the reading process, so that we don't have to pass 4 or 5
 * arguments to every function in ptot.c.  This is also used
 * to share data with inflate.c.
 */

#define IOBUF_SIZE 8192 /* Must be at least 768 for PLTE */

typedef struct _png_state
{
    FILE *inf;
    IMG_INFO *image;
    U8 *buf, *bufp;
    U32 crc, bytes_remaining;
    U32 inflated_chunk_size;
    U32 current_chunk_name;
    S32 bytes_in_buf;       /* Must be signed! */
    U32 inflate_window_size;
    U8 *inflate_window;
    U16 inflate_flags;
    U16 sum1, sum2;
    U8 *last_line, *this_line;
    size_t byte_offset;
    size_t line_size, line_x;
    int interlace_pass;
    U32 current_row, current_col;
    int cur_filter;
    int got_first_chunk;
    int got_first_idat;
} PNG_STATE;

#endif

// Ŀ
//  JPG-lib header 
// 

#ifdef VYHEN_JPG
/* #ident   "@(#)x11:contrib/clients/xloadimage/jpeg.h 1.10 93/07/23 Labtam" */

#ifndef JPEG_H
#define JPEG_H

#define INIT_IMAGE_OPTS(istr){  \
    istr.name= NULL;            \
    istr.loader_idx= -1;        \
    istr.atx= istr.aty= 0;      \
    istr.ats= FALSE;            \
    istr.border= NULL;          \
    istr.bright= 0;             \
    istr.center= 0;             \
    istr.clipx= istr.clipy= 0;  \
    istr.clipw= istr.cliph= 0;  \
    istr.colordither= 0;        \
    istr.colors= 0;             \
    istr.delay= -1;             \
    istr.dither= 0;             \
    istr.gamma= 0.0;            \
    istr.gray= 0;               \
    istr.merge= 0;              \
    istr.normalize= 0;          \
    istr.rotate= 0;             \
    istr.smooth= 0;             \
    istr.title= NULL;           \
    istr.xpmkeyc= 0;            \
    istr.xzoom= istr.yzoom= 0;  \
    istr.fg= istr.bg= NULL;     \
    istr.done_to= FALSE;        \
    istr.to_argv= NULL; }

/*
 * This is based on jinclude.h, jconfig.h + other stuff,
 * customized for use with xli.
 */

/*************************************************************************/
/*
 * jinclude.h, modified for xloadimage use
 *
 * Copyright (C) 1991, 1992, 1993, Thomas G. Lane.
 * This file is part of the Independent JPEG Group's software.
 * For conditions of distribution and use, see the accompanying README file.
 *
 * This is the central file that's #include'd by all the JPEG .c files.
 * Its purpose is to provide a single place to fix any problems with
 * including the wrong system include files.
 * You can edit these declarations if you use a system with nonstandard
 * system include files.
 */


/*
 * <stdio.h> is included to get the FILE typedef and NULL macro.
 * Note that the core portable-JPEG files do not actually do any I/O
 * using the stdio library; only the user interface, error handler,
 * and file reading/writing modules invoke any stdio functions.
 * (Well, we did cheat a bit in jmemmgr.c, but only if MEM_STATS is defined.)
 */

#include <stdio.h>

/*
 * We need the size_t typedef, which defines the parameter type of malloc().
 * In an ANSI-conforming implementation this is provided by <stdio.h>,
 * but on non-ANSI systems it's more likely to be in <sys/types.h>.
 */

#include <sys/types.h>

/*
 * In ANSI C, and indeed any rational implementation, size_t is also the
 * type returned by sizeof().  However, it seems there are some irrational
 * implementations out there, in which sizeof() returns an int even though
 * size_t is defined as long or unsigned long.  To ensure consistent results
 * we always use this SIZEOF() macro in place of using sizeof() directly.
 */

#undef SIZEOF                   /* in case you included X11/xmd.h */
#define SIZEOF(object)  ((size_t) sizeof(object))

/*
 * fread() and fwrite() are always invoked through these macros.
 * On some systems you may need to twiddle the argument casts.
 * CAUTION: argument order is different from underlying functions!
 */

#define JFREAD(file,buf,sizeofbuf)  \
  ((size_t) fread((void *) (buf), (size_t) 1, (size_t) (sizeofbuf), (file)))
#define JFWRITE(file,buf,sizeofbuf)  \
  ((size_t) fwrite((const void *) (buf), (size_t) 1, (size_t) (sizeofbuf), (file)))

/*
 * We need the memcpy() and strcmp() functions, plus memory zeroing.
 * ANSI and System V implementations declare these in <string.h>.
 * BSD doesn't have the mem() functions, but it does have bcopy()/bzero().
 * Some systems may declare memset and memcpy in <memory.h>.
 *
 * NOTE: we assume the size parameters to these functions are of type size_t.
 * Change the casts in these macros if not!
 */

#if defined(SYSV) || defined(VMS)
#include <string.h>
#define MEMZERO(target,size)    memset((void *)(target), 0, (size_t)(size))
#define MEMCOPY(dest,src,size)  memcpy((void *)(dest), (const void *)(src), (size_t)(size))
#else /* !SYSV && !VMS */
#include <strings.h>
#define MEMZERO(target,size)    bzero((void *)(target), (size_t)(size))
#define MEMCOPY(dest,src,size)  bcopy((const void *)(src), (void *)(dest), (size_t)(size))
#endif /* !SYSV && !VMS */


/*************************************************************************/
/*
 * jconfig.h, modified for xloadimage use
 *
 * Copyright (C) 1991, 1992, 1993, Thomas G. Lane.
 * This file is part of the Independent JPEG Group's software.
 * For conditions of distribution and use, see the accompanying README file.
 *
 * This file contains preprocessor declarations that help customize
 * the JPEG software for a particular application, machine, or compiler.
 * Edit these declarations as needed (or add -D flags to the Makefile).
 */


/*
 * These symbols indicate the properties of your machine or compiler.
 */

/* Does your compiler support function prototypes? */

#undef PROTO                    /* xloadimage does not use function protos */

/* Does your compiler support the declaration "unsigned char" ? */
/* How about "unsigned short" ? */

#define HAVE_UNSIGNED_CHAR
#define HAVE_UNSIGNED_SHORT

/* Define this if an ordinary "char" type is unsigned.
 * If you're not sure, leaving it undefined will work at some cost in speed.
 * If you defined HAVE_UNSIGNED_CHAR then it doesn't matter very much.
 */

/* #define CHAR_IS_UNSIGNED */

/* Define this if your compiler implements ">>" on signed values as a logical
 * (unsigned) shift; leave it undefined if ">>" is a signed (arithmetic) shift,
 * which is the normal and rational definition.
 */

/* #define RIGHT_SHIFT_IS_UNSIGNED */

/* Define "void" as "char" if your compiler doesn't know about type void.
 * NOTE: be sure to define void such that "void *" represents the most general
 * pointer type, e.g., that returned by malloc().
 */

/* #define void char */

/* Define const as empty if your compiler doesn't know the "const" keyword. */
/* (Even if it does, defining const as empty won't break anything.) */

#define const

/* For 80x86 machines, you need to define NEED_FAR_POINTERS,
 */

#undef NEED_FAR_POINTERS        /* xloadimage does not run under MessyDOS */


/* If your compiler supports inline functions, define INLINE
 * as the inline keyword; otherwise define it as empty.
 */

#ifdef __GNUC__                 /* for instance, GNU C knows about inline */
#define INLINE __inline__
#endif
#ifndef INLINE                  /* default is to define it as empty */
#define INLINE
#endif

/* On a few systems, type boolean and/or macros FALSE, TRUE may appear
 * in standard header files.  Or you may have conflicts with application-
 * specific header files that you want to include together with these files.
 * In that case you need only comment out these definitions.
 */

#ifndef HAVE_BOOLEAN
#define HAVE_BOOLEAN
typedef int boolean;
#endif

#ifndef FALSE
#define FALSE   0
#define TRUE    1
#endif

/* This defines the size of the I/O buffers for entropy compression
 * and decompression; you could reduce it if memory is tight.
 */

#define JPEG_BUF_SIZE   4096 /* bytes */



/* These symbols determine the JPEG functionality supported. */

/*
 * These defines indicate whether to include various optional functions.
 * Undefining some of these symbols will produce a smaller but less capable
 * program file.  Note that you can leave certain source files out of the
 * compilation/linking process if you've #undef'd the corresponding symbols.
 * (You may HAVE to do that if your compiler doesn't like null source files.)
 */

/* Arithmetic coding is unsupported for legal reasons.  Complaints to IBM. */

/* Decoder capability options: */
#undef  D_ARITH_CODING_SUPPORTED    /* Arithmetic coding back end? */
#define D_MULTISCAN_FILES_SUPPORTED /* Multiple-scan JPEG files? */
#undef BLOCK_SMOOTHING_SUPPORTED   /* Block smoothing during decoding? */
#undef QUANT_1PASS_SUPPORTED    /* 1-pass color quantization? */
#undef QUANT_2PASS_SUPPORTED    /* 2-pass color quantization? */
/* these defines indicate which JPEG file formats are allowed */
#define JFIF_SUPPORTED          /* JFIF or "raw JPEG" files */
#undef  JTIFF_SUPPORTED         /* JPEG-in-TIFF (not yet implemented) */

/* more capability options later, no doubt */


/*
 * Define exactly one of these three symbols to indicate whether you want
 * 8-bit, 12-bit, or 16-bit sample (pixel component) values.  8-bit is the
 * default and is nearly always the right thing to use.  You can use 12-bit if
 * you need to support image formats with more than 8 bits of resolution in a
 * color value.  16-bit should only be used for the lossless JPEG mode (not
 * currently supported).  Note that 12- and 16-bit values take up twice as
 * much memory as 8-bit!
 * Note: if you select 12- or 16-bit precision, it is dangerous to turn off
 * ENTROPY_OPT_SUPPORTED.  The standard Huffman tables are only good for 8-bit
 * precision, so jchuff.c normally uses entropy optimization to compute
 * usable tables for higher precision.  If you don't want to do optimization,
 * you'll have to supply different default Huffman tables.
 */

#define EIGHT_BIT_SAMPLES
#undef  TWELVE_BIT_SAMPLES
#undef  SIXTEEN_BIT_SAMPLES



/*
 * The remaining definitions don't need to be hand-edited in most cases.
 * You may need to change these if you have a machine with unusual data
 * types; for example, "char" not 8 bits, "short" not 16 bits,
 * or "long" not 32 bits.  We don't care whether "int" is 16 or 32 bits,
 * but it had better be at least 16.
 */

/* First define the representation of a single pixel element value. */

#ifdef EIGHT_BIT_SAMPLES
/* JSAMPLE should be the smallest type that will hold the values 0..255.
 * You can use a signed char by having GETJSAMPLE mask it with 0xFF.
 * If you have only signed chars, and you are more worried about speed than
 * memory usage, it might be a win to make JSAMPLE be short.
 */

#ifdef HAVE_UNSIGNED_CHAR

typedef unsigned char JSAMPLE;
#define GETJSAMPLE(value)  (value)

#else /* not HAVE_UNSIGNED_CHAR */
#ifdef CHAR_IS_UNSIGNED

typedef char JSAMPLE;
#define GETJSAMPLE(value)  (value)

#else /* not CHAR_IS_UNSIGNED */

typedef char JSAMPLE;
#define GETJSAMPLE(value)  ((value) & 0xFF)

#endif /* CHAR_IS_UNSIGNED */
#endif /* HAVE_UNSIGNED_CHAR */

#define BITS_IN_JSAMPLE   8
#define MAXJSAMPLE      255
#define CENTERJSAMPLE   128

#endif /* EIGHT_BIT_SAMPLES */


#ifdef TWELVE_BIT_SAMPLES
/* JSAMPLE should be the smallest type that will hold the values 0..4095. */
/* On nearly all machines "short" will do nicely. */

typedef short JSAMPLE;
#define GETJSAMPLE(value)  (value)

#define BITS_IN_JSAMPLE   12
#define MAXJSAMPLE      4095
#define CENTERJSAMPLE   2048

#endif /* TWELVE_BIT_SAMPLES */


#ifdef SIXTEEN_BIT_SAMPLES
/* JSAMPLE should be the smallest type that will hold the values 0..65535. */

#ifdef HAVE_UNSIGNED_SHORT

typedef unsigned short JSAMPLE;
#define GETJSAMPLE(value)  (value)

#else /* not HAVE_UNSIGNED_SHORT */

/* If int is 32 bits this'll be horrendously inefficient storage-wise.
 * But since we don't actually support 16-bit samples (ie lossless coding) yet,
 * I'm not going to worry about making a smarter definition ...
 */
typedef unsigned int JSAMPLE;
#define GETJSAMPLE(value)  (value)

#endif /* HAVE_UNSIGNED_SHORT */

#define BITS_IN_JSAMPLE    16
#define MAXJSAMPLE      65535
#define CENTERJSAMPLE   32768

#endif /* SIXTEEN_BIT_SAMPLES */


/* Here we define the representation of a DCT frequency coefficient.
 * This should be a signed 16-bit value; "short" is usually right.
 * It's important that this be exactly 16 bits, no more and no less;
 * more will cost you a BIG hit of memory, less will give wrong answers.
 */

typedef short JCOEF;


/* The remaining typedefs are used for various table entries and so forth.
 * They must be at least as wide as specified; but making them too big
 * won't cost a huge amount of memory, so we don't provide special
 * extraction code like we did for JSAMPLE.  (In other words, these
 * typedefs live at a different point on the speed/space tradeoff curve.)
 */

/* UINT8 must hold at least the values 0..255. */

#ifdef HAVE_UNSIGNED_CHAR
typedef unsigned char UINT8;
#else /* not HAVE_UNSIGNED_CHAR */
#ifdef CHAR_IS_UNSIGNED
typedef char UINT8;
#else /* not CHAR_IS_UNSIGNED */
typedef short UINT8;
#endif /* CHAR_IS_UNSIGNED */
#endif /* HAVE_UNSIGNED_CHAR */

/* UINT16 must hold at least the values 0..65535. */

#ifdef HAVE_UNSIGNED_SHORT
typedef unsigned short UINT16;
#else /* not HAVE_UNSIGNED_SHORT */
typedef unsigned int UINT16;
#endif /* HAVE_UNSIGNED_SHORT */

/* INT16 must hold at least the values -32768..32767. */

#ifndef XMD_H                   /* X11/xmd.h correctly defines INT16 */
typedef short INT16;
#endif

/* INT32 must hold signed 32-bit values; if your machine happens */
/* to have 64-bit longs, you might want to change this. */

#ifndef XMD_H                   /* X11/xmd.h correctly defines INT32 */
typedef long INT32;
#endif

/*************************************************************************/

/* #ident       "@(#)x11:contrib/clients/xloadimage/xli.h 1.4 94/07/29 Labtam" */
/* xli.h:
 *
 * jim frost 06.21.89
 *
 * Copyright 1989 Jim Frost.  See included file "copyright.h" for complete
 * copyright information.
 */

#if defined(SVR4) && !defined(SYSV)
# define SYSV           /* SYSV is out System V flag */
#endif

#include <stdio.h>
#include <math.h>

/* #ident       "@(#)x11:contrib/clients/xloadimage/ddxli.h 1.3 94/07/29 Labtam" */
/*
 * General Device dependent code for xli.
 *
 * Author; Graeme W. Gill
 */

/**********************/
/* OS dependent stuff */

#ifndef MSDOS   /* If X11 version */
#include <X11/X.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#include <X11/cursorfont.h>
#else /* MSDOS Version */
//#include <graphics.h>
#include <pc.h>
//#include <sys/registers.h>

#endif /* MSDOS Version */

#if defined(SYSV) || defined(VMS)
#include <string.h>
#ifndef index /* some SysV's do this for you */
#define index strchr
#endif
#ifndef rindex
#define rindex strrchr
#endif
#ifndef HAS_MEMCPY
#define HAS_MEMCPY
#endif
#else /* !SYSV && !VMS */
#include <strings.h>
#endif /* !SYSV && !VMS */

#ifdef VMS
#define R_OK 4
#define NO_UNCOMPRESS
#endif

/* equate bcopy w/ memcpy and bzero w/ memset where appropriate.
 */

#ifdef HAS_MEMCPY
#ifndef bcopy
#define bcopy(S,D,N) memcpy((char *)(D),(char *)(S),(N))
#endif
#ifndef bzero
#define bzero(P,N) memset((P),'\0',(N))
#endif
#ifndef bfill
#define bfill(P,N,C) memset((P),(C),(N))
#endif
#else /* not HAS_MEMCPY */
void    bfill();
#endif /* not HAS_MEMCPY */

/***************************/
/* xli specific data types */

#undef HAS_SIGNED_CHAR                  /* If signed char is a legal declaration */
                                                                /* else assume char is signed by default */

typedef unsigned long  Pixel;     /* what X thinks a pixel is */
typedef unsigned short Intensity; /* what X thinks an RGB intensity is */
typedef unsigned char  Byte;      /* unsigned byte type */
#ifdef HAS_SIGNED_CHAR
typedef signed   char  sbyte;     /* signed byte type */
#else
typedef char  sbyte;              /* signed byte type */
#endif

#ifndef HAVE_BOOLEAN
#define HAVE_BOOLEAN
typedef int boolean;
#endif

#ifndef FALSE
#define FALSE 0
#define TRUE (!FALSE)
#endif

/**************************************************/
/* Display device dependent Information structure */
typedef struct {
        int  width;             /* Display width and height */
        int  height;
#ifndef MSDOS   /* If X11 version */
        Display      *disp;
        int           scrn;
        Colormap      colormap;
#else   /* else is MSDOS version */
        unsigned char *base;
        int  span;
#endif  /* MSDOS version */
} DisplayInfo;

#ifndef MSDOS   /* If X11 version */

/* This struct holds the X-client side bits for a rendered image.
 */

typedef struct {
  Display  *disp;       /* destination display */
  int       scrn;       /* destination screen */
  int       depth;      /* depth of drawable we want/have */
  Drawable  drawable;   /* drawable to send image to */
  Pixel    *index;              /* array of pixel values allocated */
  int       no;             /* number of pixels in the array */
  boolean   rootimage;  /* True if is a root image - eg, retain colors */
  Pixel     foreground; /* foreground and background pixels for mono images */
  Pixel     background;
  Colormap  cmap;       /* colormap used for image */
  GC        gc;         /* cached gc for sending image */
  XImage   *ximage;     /* ximage structure */
} XImageInfo;

/* Function declarations */
void        sendXImage(); /* send.c */
XImageInfo *imageToXImage();
Pixmap      ximageToPixmap();
void        freeXImage();

Visual *getBestVisual(); /* visual.c */

char *xliDisplayName();         /* ddxli.c */
int xliParseXColor();
int xliDefaultVisual();
void xliGammaCorrectXColor();

#else /* else is MSDOS version */

/* We need to understand X11 style visuals for xwd and xpm files. */
#define StaticGray              0
#define GrayScale               1
#define StaticColor             2
#define PseudoColor             3
#define TrueColor               4
#define DirectColor             5

/* and some flags for our imitation lookup color */
#define DoRed                   (1<<0)
#define DoGreen                 (1<<1)
#define DoBlue                  (1<<2)

/* and some xwd definitions */
#define XYBitmap                0       /* depth 1, XYFormat */
#define XYPixmap                1       /* depth == drawable depth */
#define ZPixmap                 2       /* depth == drawable depth */

/* and some data order definitions */
#define LSBFirst                0
#define MSBFirst                1

#endif /* else is MSDOS version */

/* #ident       "@(#)x11:contrib/clients/xloadimage/image.h 6.15 93/07/23 Labtam" */
/* image.h:
 *
 * portable image type declarations
 *
 * jim frost 10.02.89
 *
 * Copyright 1989 Jim Frost.  See included file "copyright.h" for complete
 * copyright information.
 */

/* the device independent equivalent of the X Color record */
typedef struct {
        unsigned long pixel;
        unsigned short red, green, blue;
        char flags;  /* do_red, do_green, do_blue */
        char pad;
} xliXColor;

typedef struct rgbmap {
  unsigned int  size;       /* size of RGB map */
  unsigned int  used;       /* number of colors used in RGB map */
  boolean       compressed; /* image uses colormap fully */
  Intensity    *red;        /* color values in X style */
  Intensity    *green;
  Intensity    *blue;
} RGBMap;

/* image structure
 */

typedef struct {
  char         *title;  /* name of image */
  unsigned int  type;   /* type of image */
  RGBMap        rgb;    /* RGB map of image if IRGB type */
  unsigned int  width;  /* width of image in pixels */
  unsigned int  height; /* height of image in pixels */
  unsigned int  depth;  /* depth of image in bits if IRGB type */
  unsigned int  pixlen; /* length of pixel if IRGB type */
  Byte         *data;   /* data rounded to full byte for each row */
  float         gamma;  /* gamma of display the image is adjusted for */
} Image;

#define IBITMAP 0 /* image is a bitmap */
#define IRGB    1 /* image is RGB */
#define ITRUE   2 /* image is true color */

#define BITMAPP(IMAGE) ((IMAGE)->type == IBITMAP)
#define RGBP(IMAGE)    ((IMAGE)->type == IRGB)
#define TRUEP(IMAGE)   ((IMAGE)->type == ITRUE)

#define TRUE_RED(PIXVAL)   (((unsigned long)((PIXVAL) & 0xff0000)) >> 16)
#define TRUE_GREEN(PIXVAL) (((unsigned long)((PIXVAL) & 0xff00)) >> 8)
#define TRUE_BLUE(PIXVAL)   ((unsigned long)((PIXVAL) & 0xff))
#define RGB_TO_TRUE(R,G,B) \
  ((((unsigned long)((R) & 0xff00)) << 8) | ((G) & 0xff00) | (((unsigned short)(B)) >> 8))

#define depthToColors(n) DepthToColorsTable[((n) < 32 ? (n) : 32)]

/*
 * this returns the (approximate) intensity of an RGB triple
 */

#define colorIntensity(R,G,B) \
  (RedIntensity[((unsigned short)(R)) >> 8] + GreenIntensity[((unsigned short)(G)) >> 8] + BlueIntensity[((unsigned short)(B)) >> 8])

extern unsigned short RedIntensity[];
extern unsigned short GreenIntensity[];
extern unsigned short BlueIntensity[];

/*
 * Architecture independent memory to value conversions.
 * Note the "Normal" internal format is big endian.
 */

#define memToVal(PTR,LEN) (                                   \
(LEN) == 1 ? (unsigned long)(                 *( (Byte *)(PTR))         ) :    \
(LEN) == 2 ? (unsigned long)(((unsigned long)(*( (Byte *)(PTR))   ))<< 8)      \
                          + (                 *(((Byte *)(PTR))+1)      ) :    \
(LEN) == 3 ? (unsigned long)(((unsigned long)(*( (Byte *)(PTR))   ))<<16)      \
                          + (((unsigned long)(*(((Byte *)(PTR))+1)))<< 8)      \
                                                  + (                 *(((Byte *)(PTR))+2)      ) :    \
             (unsigned long)(((unsigned long)(*( (Byte *)(PTR))   ))<<24)      \
                                                  + (((unsigned long)(*(((Byte *)(PTR))+1)))<<16)      \
                                                  + (((unsigned long)(*(((Byte *)(PTR))+2)))<< 8)      \
                                                  + (                 *(((Byte *)(PTR))+3)      ) )

#define valToMem(VAL,PTR,LEN)  (                                          \
(LEN) == 1 ? (*( (Byte *)(PTR)   ) = ( VAL     ) ) : \
(LEN) == 2 ? (*( (Byte *)(PTR)   ) = (((unsigned long)(VAL))>> 8),        \
              *(((Byte *)(PTR))+1) = ( VAL     ) ) : \
(LEN) == 3 ? (*( (Byte *)(PTR)   ) = (((unsigned long)(VAL))>>16),        \
              *(((Byte *)(PTR))+1) = (((unsigned long)(VAL))>> 8),        \
              *(((Byte *)(PTR))+2) = ( VAL     ) ) : \
             (*( (Byte *)(PTR)   ) = (((unsigned long)(VAL))>>24),        \
              *(((Byte *)(PTR))+1) = (((unsigned long)(VAL))>>16),        \
              *(((Byte *)(PTR))+2) = (((unsigned long)(VAL))>> 8),        \
              *(((Byte *)(PTR))+3) = ( VAL     ) ))

#define memToValLSB(PTR,LEN) (                                \
(LEN) == 1 ? (unsigned long)(                 *( (Byte *)(PTR))         ) :    \
(LEN) == 2 ? (unsigned long)(                 *( (Byte *)(PTR))         )      \
                          + (((unsigned long)(*(((Byte *)(PTR))+1)))<< 8) :    \
(LEN) == 3 ? (unsigned long)(                 *( (Byte *)(PTR))         )      \
                          + (((unsigned long)(*(((Byte *)(PTR))+1)))<< 8)      \
                                                  + (((unsigned long)(*(((Byte *)(PTR))+2)))<<16) :    \
             (unsigned long)(                 *( (Byte *)(PTR))         )      \
                                                  + (((unsigned long)(*(((Byte *)(PTR))+1)))<< 8)      \
                                                  + (((unsigned long)(*(((Byte *)(PTR))+2)))<<16)      \
                                                  + (((unsigned long)(*(((Byte *)(PTR))+3)))<<24) )


/* this is provided for orthagonality
 */

#define valToMemLSB(VAL,PTR,LEN) (                                        \
(LEN) == 1 ? (*( (Byte *)(PTR)   ) = ( VAL     ) ) : \
(LEN) == 2 ? (*( (Byte *)(PTR)   ) = ( VAL     ),                         \
              *(((Byte *)(PTR))+1) = (((unsigned long)(VAL))>> 8) ) : \
(LEN) == 3 ? (*( (Byte *)(PTR)   ) = ( VAL     ),                         \
              *(((Byte *)(PTR))+1) = (((unsigned long)(VAL))>> 8),                         \
              *(((Byte *)(PTR))+2) = (((unsigned long)(VAL))>>16) ) : \
             (*( (Byte *)(PTR)   ) = ( VAL     ),                         \
              *(((Byte *)(PTR))+1) = (((unsigned long)(VAL))>> 8),                         \
              *(((Byte *)(PTR))+2) = (((unsigned long)(VAL))>>16),                         \
              *(((Byte *)(PTR))+3) = (((unsigned long)(VAL))>>24)) )

/* #ident       "@(#)x11:contrib/clients/xloadimage/options.h 6.15 94/07/29 Labtam" */
/* options.h:
 *
 * optionNumber() definitions
 *
 * jim frost 10.03.89
 *
 * Copyright 1989 Jim Frost.  See included file "copyright.h" for complete
 * copyright information.
 */

/* enum with the options in it.  If you add one to this you also have to
 * add its information to Options[] in options.c before it becomes available.
 */

typedef enum option_id {

  /* flags
   */

  OPT_NOTOPT= 0, OPT_BADOPT, OPT_SHORTOPT,
  NAME,

  /* general options
   */

  GENERAL_OPTIONS_START,                        /* marker */

  DBUG, DUMPCORE, DEFAULT, DELAY,
  DISPLAY, DISPLAYGAMMA, FILLSCREEN, FIT, FORK, FULLSCREEN, GOTO, GEOMETRY, HELP, IDENTIFY,
  INSTALL, LIST, ONROOT, PATH, PIXMAP, PRIVATE, QUIET, SUPPORTED, VERBOSE,
  VER_NUM, VIEW, VISUAL, WINDOWID,

  GENERAL_OPTIONS_END,                          /* marker */

  /* local options
   */

  LOCAL_OPTIONS_START,                  /* marker */

  AT, BACKGROUND, BORDER, BRIGHT, CENTER, CLIP, COLORDITHER, COLORS,
  DITHER, EXPAND, FOREGROUND, GAMMA, GRAY, HALFTONE, IDELAY, INVERT, MERGE,
  NEWOPTIONS, NORMALIZE, ROTATE, SMOOTH, TITLE,
  XPM,
  XZOOM, YZOOM, ZOOM,

  LOCAL_OPTIONS_END                             /* marker */

} OptionId;

typedef struct option_array {
  char     *name;        /* name of the option minus preceeding '-' */
  OptionId  option_id;   /* OptionId of this option */
  char     *args;        /* arguments this option uses or NULL if none */
  char     *description; /* description of this option */
} OptionArray;

OptionId optionNumber(); /* options.c */

#define isGeneralOption(opno) ((((int)(opno) > (int)GENERAL_OPTIONS_START) && \
                              ((int)(opno) < (int)GENERAL_OPTIONS_END))       \
                              ? TRUE : FALSE)

#define isLocalOption(opno) ((((int)(opno) > (int)LOCAL_OPTIONS_START) && \
                            ((int)(opno) < (int)LOCAL_OPTIONS_END))       \
                            ? TRUE : FALSE)

#ifdef MSDOS    /* gcc under MSDOS compatibility fudges */
//#define EISDIR  37              /* Attempt to write on a directory */
#endif /* MSDOS */


#ifndef MAXIMAGES
#define MAXIMAGES BUFSIZ /* max # of images we'll try to load at once */
#endif


/* image name and option structure used when processing arguments
 */

typedef struct {
  char         *name;         /* name of image */
  int           loader_idx;   /* loader last used successfully with image */
  int           atx, aty;     /* location to load image at */
  boolean       ats;          /* TRUE if atx and aty have been set */
  unsigned int  bright;       /* brightness multiplier */
  unsigned int  center;       /* true if image is to be centered */
  int           clipx, clipy; /* Offset and area of image to be used */
  unsigned int  clipw, cliph;
  char         *border;       /* Border colour used in clipping */
  xliXColor     bordercol;    /* X RGB of above */
  unsigned int  colordither;  /* true if color reduction is to dither image */
  unsigned int  colors;       /* max # of colors to use for this image */
  int           delay;        /* # of seconds delay before auto pic advance */
  unsigned int  dither;       /* true if image is to be dithered */
  boolean       expand;       /* true if image should be forced to TrueColor depth */
  float         gamma;        /* display gamma */
  unsigned int  gray;         /* true if image is to be grayed */
  unsigned int  merge;        /* true if we should merge onto previous */
  unsigned int  normalize;    /* true if image is to be normalized */
  int           rotate;       /* # degrees to rotate image */
  unsigned int  smooth;       /* true if image is to be smoothed */
  char         *title;        /* Overide title on image */
  unsigned int  xzoom, yzoom; /* zoom percentages */
  char         *fg, *bg;      /* foreground/background colors if mono image */
  boolean       done_to;      /* TRUE if we have already looked for trailing options */
  char        **to_argv;      /* IF non NULL, text of trailing options, parsed as for argv */
  int           xpmkeyc;      /* Overideing color context key value for xpm pixmaps */
} ImageOptions;

/* globals and global options
 */

typedef struct {
  DisplayInfo   dinfo;          /* device dependent display information */
  char         *argv0;          /* name of this programs */
  char         *lastfunc;       /* name of last function called (used in error reps) */
  int           _Xdebug;        /* dump on X error flag */
  int           _DumpCore;      /* dump on signal flag */
  boolean       verbose;
  float         display_gamma;
  char         *dname;
  boolean       do_fork;
  boolean       fillscreen;
  boolean       fit;
  boolean       fullscreen;
  char         *go_to;        /* label to goto */
  boolean       identify;
  boolean       install;
  boolean       onroot;
  boolean       private_cmap;
  boolean       set_default;
  boolean       use_pixmap;
  char         *user_geometry;  /* -geometry passed by user */
  int           visual_class;    /* user-defined visual class */
#ifndef MSDOS   /* If X11 version */
  unsigned int  dest_window;    /* window id to put image onto */
#endif
} GlobalsRec;

/* Global declarations */

extern GlobalsRec globals;

#define CURRFUNC(aa) (globals.lastfunc = (aa))

/* Gamma correction stuff
 */

/* the default target display gamma. This can be overridden on the */
/* command line or by settin an environment variable. */
#define DEFAULT_DISPLAY_GAMMA 2.2

/* the default IRGB image gamma. This can be overridden on the */
/* command line. */
#define DEFAULT_IRGB_GAMMA 2.2

/* Compare gammas for equality */
#define GAMMA_NOT_EQUAL(g1,g2)   ((g1) > ((g2) + 0.00001) || (g1) < ((g2) - 0.00001))

/*
 * Cached/uudecoded/uncompressed file I/O structures.
 */

struct cache {
  Byte         *end;
  Byte          buf[BUFSIZ];
  struct cache *next;
  boolean       eof;
};

#define UULEN 128   /* uudecode buffer length */
#define UUBODY 1   /* uudecode state - reading body of file */
#define UUSKIP 2   /* uudecode state - skipping garbage */
#define UUEOF 3   /* uudecode stat - found eof */

typedef struct {
  unsigned int  type;     /* ZIO file type */
  boolean       nocache;  /* TRUE if caching has been disabled */
  FILE         *stream;   /* file input stream */
  char         *filename; /* filename */
  struct cache *data;     /* data cache */
  struct cache *dataptr;  /* ptr to current cache block */
  Byte         *bufptr;   /* ptr within current cache block */
  Byte         *endptr;   /* ptr to end of current cache block */
  Byte         *auxb;     /* non NULL if auxiliary buffer in use */
  Byte         *oldbufptr;   /* save bufptr here when aux buffer is in use */
  Byte         *oldendptr;   /* save endptr here when aux buffer is in use */
  boolean       eof;      /* TRUE if we are at encountered EOF */
  Byte          buf[BUFSIZ]; /* getc buffer when un-cached */
  boolean       uudecode; /* TRUE if being uudecoded */
  Byte          uubuf[UULEN]; /* uu decode buffer */
  Byte         *uunext,*uuend;
  int           uustate;      /* state of uu decoder */
} ZFILE;

#define ZSTANDARD 0 /* standard file */
#define ZPIPE     1 /* file is a pipe (ie uncompress) */
#define ZSTDIN    2 /* file is stdin */

/*
   C library functions that may not be decalared elsewehere
 */

int    atoi();
long   atol();
double atof();
char *getenv();

/*
 * function declarations
 */

/*
 * Note on image processing functions :-
 *
 * The assumption is always that an image processing function that returns
 * an image may return a new image or one of the input images, and that
 * input images are preserved.
 *
 * This means that within an image processing function the following
 * technique of managinging intermediate images is recomended:
 *
 * Image *func(isrc)
 * Image *isrc;
 *   {
 *   Image *src = isrc, *dst, *tmp;
 *   .
 *   .
 *   tmp = other_func(src);
 *   if (src != tmp && src != isrc)
 *     freeImage(src);
 *   src = tmp;
 *   .
 *   .
 *   dst = process(src);
 *   .
 *   .
 *   if (src != isrc)
 *     freeImage(src);
 *   return (dst);
 *
 * This may seem redundant in places, but allows changes to be made
 * without looking at the overal image structure usage.
 *
 */

void supportedImageTypes(); /* imagetypes.c */

char *tail(); /* misc.c */
void memoryExhausted();
void internalError();
void version();
void usage();
void goodImage();
Image *processImage();
int errorHandler();
extern short LEHexTable[];  /* Little Endian conversion value */
extern short BEHexTable[];  /* Big Endian conversion value */
#define HEXSTART_BAD -1         /* bitmap_faces useage */
#define HEXDELIM_BAD -2
#define HEXDELIM_IGNORE -3
#define HEXBAD   -4
void initLEHexTable();
void initBEHexTable();
int hstoi();                            /* ascii hex number to integer (string, length) */

char *expandPath(); /* path.c */
int findImage();
void listImages();
void loadPathsAndExts();
void showPath();

void imageOnRoot(); /* root.c */

void cleanUpWindow();   /* window.c */
char imageInWindow();

int   visualClassFromName();    /* options.c */
char *nameOfVisualClass();

Image *clip(); /* clip.c */

void brighten(); /* bright.c */
void equalize();
void gray();
Image *normalize();
void gammacorrect();
extern int gammamap[256];
#define GAMMA16(color16) (gammamap[(color16)>>8]<<8)
#define GAMMA8(color8) (gammamap[(color8)])
#define GAMMA16to8(color16) (gammamap[(color16)>>8])

void compress(); /* compress.c */

Image *dither(); /* dither.c */

void fill(); /* fill.c */

void fold(); /* fold.c */

Image *halftone(); /* halftone.c */

Image *loadImage(); /* imagetypes.c */
void   identifyImage();
void   goodImage();

Image *merge(); /* merge.c */

extern unsigned long DepthToColorsTable[]; /* new.c */
unsigned long colorsToDepth();
char  *dupString();
Image *newBitImage();
Image *newRGBImage();
Image *newTrueImage();
void   freeImage();
void   freeImageData();
void   newRGBMapData();
void   resizeRGBMapData();
void   freeRGBMapData();
Byte  *lcalloc();
Byte  *lmalloc();
Byte  *lrealloc();
void   lfree();

Image *reduce(); /* reduce.c */
Image *expandtotrue();
Image *expandbittoirgb();
Image *expandirgbdepth();

Image *rotate(); /* rotate.c */

Image *smooth(); /* smooth.c */

void          flipBits();       /* value.c */

ZFILE   *zopen(); /* zio.c */
int      zread();
void     zunread();
char    *zgets();
boolean  zrewind();
void     zclose();
void     znocache();
void     zreset();
int     _zgetc();
boolean _zopen();
void    _zreset();
void    _zclear();
boolean _zreopen();

#define zgetc(zf) (((zf)->bufptr < (zf)->endptr) ? *(zf)->bufptr++ : _zgetc(zf))

Image *zoom(); /* zoom.c */

boolean xliOpenDisplay();       /* ddxli.c */

#ifdef MSDOS
void argexp();          /* doslib.c */
#endif

/* #ident       "@(#)x11:contrib/clients/xloadimage/jpeglib.h 1.3 93/07/23 Labtam" */
/*
 * jpegdata.h
 *
 * Copyright (C) 1991, 1992, Thomas G. Lane.
 * This file is part of the Independent JPEG Group's software.
 * For conditions of distribution and use, see the accompanying README file.
 *
 * This file defines shared data structures for the various JPEG modules.
 */


/*
 * You might need to change some of the following declarations if you are
 * using the JPEG software within a surrounding application program
 * or porting it to an unusual system.
 */


/* If the source or destination of image data is not to be stdio streams,
 * these types may need work.  You can replace them with some kind of
 * pointer or indicator that is useful to you, or just ignore 'em.
 * Note that the user interface and the various jrdxxx/jwrxxx modules
 * will also need work for non-stdio input/output.
 */

typedef FILE * JFILEREF;        /* source or dest of JPEG-compressed data */

typedef FILE * IFILEREF;        /* source or dest of non-JPEG image data */


/* These defines are used in all function definitions and extern declarations.
 * You could modify them if you need to change function linkage conventions,
 * as is shown below for use with C++.  Another application would be to make
 * all functions global for use with code profilers that require it.
 * NOTE: the C++ test does the right thing if you are reading this include
 * file in a C++ application to link to JPEG code that's been compiled with a
 * regular C compiler.  I'm not sure it works if you try to compile the JPEG
 * code with C++.
 */

#define METHODDEF static        /* a function called through method pointers */
#define LOCAL     static        /* a function used only in its module */
#define GLOBAL                  /* a function referenced thru EXTERNs */
#ifdef __cplusplus
#define EXTERN    extern "C"    /* a reference to a GLOBAL function */
#else
#define EXTERN    extern        /* a reference to a GLOBAL function */
#endif


/* Here is the pseudo-keyword for declaring pointers that must be "far"
 * on 80x86 machines.  Most of the specialized coding for 80x86 is handled
 * by just saying "FAR *" where such a pointer is needed.  In a few places
 * explicit coding is needed; see uses of the NEED_FAR_POINTERS symbol.
 */

#ifdef NEED_FAR_POINTERS
#define FAR  far
#else
#define FAR
#endif



/* The remaining declarations are not system-dependent, we hope. */


/*
 * NOTE: if you have an ancient, strict-K&R C compiler, it may choke on the
 * similarly-named fields in Compress_info_struct and Decompress_info_struct.
 * If this happens, you can get around it by rearranging the two structs so
 * that the similarly-named fields appear first and in the same order in
 * each struct.  Since such compilers are now pretty rare, we haven't done
 * this in the portable code, preferring to maintain a logical ordering.
 */



/* This macro is used to declare a "method", that is, a function pointer. */
/* We want to supply prototype parameters if the compiler can cope. */
/* Note that the arglist parameter must be parenthesized! */

#ifdef PROTO
#define METHOD(type,methodname,arglist)  type (*methodname) arglist
#else
#define METHOD(type,methodname,arglist)  type (*methodname) ()
#endif

/* Forward references to lists of method pointers */
typedef struct External_methods_struct * external_methods_ptr;
typedef struct Compress_methods_struct * compress_methods_ptr;
typedef struct Decompress_methods_struct * decompress_methods_ptr;


/* Data structures for images containing either samples or coefficients. */
/* Note that the topmost (leftmost) index is always color component. */
/* On 80x86 machines, the image arrays are too big for near pointers, */
/* but the pointer arrays can fit in near memory. */

typedef JSAMPLE FAR *JSAMPROW;  /* ptr to one image row of pixel samples. */
typedef JSAMPROW *JSAMPARRAY;   /* ptr to some rows (a 2-D sample array) */
typedef JSAMPARRAY *JSAMPIMAGE; /* a 3-D sample array: top index is color */


#define DCTSIZE         8       /* The basic DCT block is 8x8 samples */
#define DCTSIZE2        64      /* DCTSIZE squared; # of elements in a block */

typedef JCOEF JBLOCK[DCTSIZE2]; /* one block of coefficients */
typedef JBLOCK FAR *JBLOCKROW;  /* pointer to one row of coefficient blocks */
typedef JBLOCKROW *JBLOCKARRAY;         /* a 2-D array of coefficient blocks */
typedef JBLOCKARRAY *JBLOCKIMAGE;       /* a 3-D array of coefficient blocks */

typedef JCOEF FAR *JCOEFPTR;    /* useful in a couple of places */


/* The input and output data of the DCT transform subroutines are of
 * the following type, which need not be the same as JCOEF.
 * For example, on a machine with fast floating point, it might make sense
 * to recode the DCT routines to use floating point; then DCTELEM would be
 * 'float' or 'double'.
 */

typedef JCOEF DCTELEM;
typedef DCTELEM DCTBLOCK[DCTSIZE2];


/* Types for JPEG compression parameters and working tables. */


typedef enum {                  /* defines known color spaces */
        CS_UNKNOWN,             /* error/unspecified */
        CS_GRAYSCALE,           /* monochrome (only 1 component) */
        CS_RGB,                 /* red/green/blue */
        CS_YCbCr,               /* Y/Cb/Cr (also known as YUV) */
        CS_YIQ,                 /* Y/I/Q */
        CS_CMYK                 /* C/M/Y/K */
} COLOR_SPACE;


typedef struct {                /* Basic info about one component */
  /* These values are fixed over the whole image */
  /* For compression, they must be supplied by the user interface; */
  /* for decompression, they are read from the SOF marker. */
        short component_id;     /* identifier for this component (0..255) */
        short component_index;  /* its index in SOF or cinfo->comp_info[] */
        short h_samp_factor;    /* horizontal sampling factor (1..4) */
        short v_samp_factor;    /* vertical sampling factor (1..4) */
        short quant_tbl_no;     /* quantization table selector (0..3) */
  /* These values may vary between scans */
  /* For compression, they must be supplied by the user interface; */
  /* for decompression, they are read from the SOS marker. */
        short dc_tbl_no;        /* DC entropy table selector (0..3) */
        short ac_tbl_no;        /* AC entropy table selector (0..3) */
  /* These values are computed during compression or decompression startup */
        long true_comp_width;   /* component's image width in samples */
        long true_comp_height;  /* component's image height in samples */
        /* the above are the logical dimensions of the downsampled image */
  /* These values are computed before starting a scan of the component */
        short MCU_width;        /* number of blocks per MCU, horizontally */
        short MCU_height;       /* number of blocks per MCU, vertically */
        short MCU_blocks;       /* MCU_width * MCU_height */
        long downsampled_width; /* image width in samples, after expansion */
        long downsampled_height; /* image height in samples, after expansion */
        /* the above are the true_comp_xxx values rounded up to multiples of */
        /* the MCU dimensions; these are the working dimensions of the array */
        /* as it is passed through the DCT or IDCT step.  NOTE: these values */
        /* differ depending on whether the component is interleaved or not!! */
} jpeg_component_info;


/* DCT coefficient quantization tables.
 * For 8-bit precision, 'INT16' should be good enough for quantization values;
 * for more precision, we go for the full 16 bits.  'INT16' provides a useful
 * speedup on many machines (multiplication & division of JCOEFs by
 * quantization values is a significant chunk of the runtime).
 * Note: the values in a QUANT_TBL are always given in zigzag order.
 */
#ifdef EIGHT_BIT_SAMPLES
typedef INT16 QUANT_VAL;        /* element of a quantization table */
#else
typedef UINT16 QUANT_VAL;       /* element of a quantization table */
#endif
typedef QUANT_VAL QUANT_TBL[DCTSIZE2];  /* A quantization table */
typedef QUANT_VAL * QUANT_TBL_PTR;      /* pointer to same */


typedef struct {                /* A Huffman coding table */
  /* These two fields directly represent the contents of a JPEG DHT marker */
        UINT8 bits[17];         /* bits[k] = # of symbols with codes of */
                                /* length k bits; bits[0] is unused */
        UINT8 huffval[256];     /* The symbols, in order of incr code length */
  /* This field is used only during compression.  It's initialized FALSE when
   * the table is created, and set TRUE when it's been output to the file.
   */
        boolean sent_table;     /* TRUE when table has been output */
  /* The remaining fields are computed from the above to allow more efficient
   * coding and decoding.  These fields should be considered private to the
   * Huffman compression & decompression modules.
   */
        /* encoding tables: */
        UINT16 ehufco[256];     /* code for each symbol */
        char ehufsi[256];       /* length of code for each symbol */
        /* decoding tables: (element [0] of each array is unused) */
        UINT16 mincode[17];     /* smallest code of length k */
        INT32 maxcode[18];      /* largest code of length k (-1 if none) */
        /* (maxcode[17] is a sentinel to ensure huff_DECODE terminates) */
        short valptr[17];       /* huffval[] index of 1st symbol of length k */
} HUFF_TBL;


#define NUM_QUANT_TBLS      4   /* quantization tables are numbered 0..3 */
#define NUM_HUFF_TBLS       4   /* Huffman tables are numbered 0..3 */
#define NUM_ARITH_TBLS      16  /* arith-coding tables are numbered 0..15 */
#define MAX_COMPS_IN_SCAN   4   /* JPEG limit on # of components in one scan */
#define MAX_SAMP_FACTOR     4   /* JPEG limit on sampling factors */
#define MAX_BLOCKS_IN_MCU   10  /* JPEG limit on # of blocks in an MCU */


/* Working data for compression */

struct Compress_info_struct {
/*
 * All of these fields shall be established by the user interface before
 * calling jpeg_compress, or by the input_init or c_ui_method_selection
 * methods.
 * Most parameters can be set to reasonable defaults by j_c_defaults.
 * Note that the UI must supply the storage for the main methods struct,
 * though it sets only a few of the methods there.
 */
        compress_methods_ptr methods; /* Points to list of methods to use */

        external_methods_ptr emethods; /* Points to list of methods to use */

        IFILEREF input_file;    /* tells input routines where to read image */
        JFILEREF output_file;   /* tells output routines where to write JPEG */

        long image_width;       /* input image width */
        long image_height;      /* input image height */
        short input_components; /* # of color components in input image */

        short data_precision;   /* bits of precision in image data */

        COLOR_SPACE in_color_space; /* colorspace of input file */
        COLOR_SPACE jpeg_color_space; /* colorspace of JPEG file */

        double input_gamma;     /* image gamma of input file */

        boolean write_JFIF_header; /* should a JFIF marker be written? */
        /* These three values are not used by the JPEG code, only copied */
        /* into the JFIF APP0 marker.  density_unit can be 0 for unknown, */
        /* 1 for dots/inch, or 2 for dots/cm.  Note that the pixel aspect */
        /* ratio is defined by X_density/Y_density even when density_unit=0. */
        UINT8 density_unit;     /* JFIF code for pixel size units */
        UINT16 X_density;       /* Horizontal pixel density */
        UINT16 Y_density;       /* Vertical pixel density */

        short num_components;   /* # of color components in JPEG image */
        jpeg_component_info * comp_info;
        /* comp_info[i] describes component that appears i'th in SOF */

        QUANT_TBL_PTR quant_tbl_ptrs[NUM_QUANT_TBLS];
        /* ptrs to coefficient quantization tables, or NULL if not defined */

        HUFF_TBL * dc_huff_tbl_ptrs[NUM_HUFF_TBLS];
        HUFF_TBL * ac_huff_tbl_ptrs[NUM_HUFF_TBLS];
        /* ptrs to Huffman coding tables, or NULL if not defined */

        UINT8 arith_dc_L[NUM_ARITH_TBLS]; /* L values for DC arithmetic-coding tables */
        UINT8 arith_dc_U[NUM_ARITH_TBLS]; /* U values for DC arithmetic-coding tables */
        UINT8 arith_ac_K[NUM_ARITH_TBLS]; /* Kx values for AC arithmetic-coding tables */

        boolean arith_code;     /* TRUE=arithmetic coding, FALSE=Huffman */
        boolean interleave;     /* TRUE=interleaved output, FALSE=not */
        boolean optimize_coding; /* TRUE=optimize entropy encoding parms */
        boolean CCIR601_sampling; /* TRUE=first samples are cosited */
        int smoothing_factor;   /* 1..100, or 0 for no input smoothing */

        /* The restart interval can be specified in absolute MCUs by setting
         * restart_interval, or in MCU rows by setting restart_in_rows
         * (in which case the correct restart_interval will be figured
         * for each scan).
         */
        UINT16 restart_interval;/* MCUs per restart interval, or 0 for no restart */
        int restart_in_rows;    /* if > 0, MCU rows per restart interval */

/*
 * These fields are computed during jpeg_compress startup
 */
        short max_h_samp_factor; /* largest h_samp_factor */
        short max_v_samp_factor; /* largest v_samp_factor */

/*
 * These fields may be useful for progress monitoring
 */

        int total_passes;       /* number of passes expected */
        int completed_passes;   /* number of passes completed so far */

/*
 * These fields are valid during any one scan
 */
        short comps_in_scan;    /* # of JPEG components output this time */
        jpeg_component_info * cur_comp_info[MAX_COMPS_IN_SCAN];
        /* *cur_comp_info[i] describes component that appears i'th in SOS */

        long MCUs_per_row;      /* # of MCUs across the image */
        long MCU_rows_in_scan;  /* # of MCU rows in the image */

        short blocks_in_MCU;    /* # of DCT blocks per MCU */
        short MCU_membership[MAX_BLOCKS_IN_MCU];
        /* MCU_membership[i] is index in cur_comp_info of component owning */
        /* i'th block in an MCU */

        /* these fields are private data for the entropy encoder */
        JCOEF last_dc_val[MAX_COMPS_IN_SCAN]; /* last DC coef for each comp */
        JCOEF last_dc_diff[MAX_COMPS_IN_SCAN]; /* last DC diff for each comp */
        UINT16 restarts_to_go;  /* MCUs left in this restart interval */
        short next_restart_num; /* # of next RSTn marker (0..7) */
};

typedef struct Compress_info_struct * compress_info_ptr;


/* Working data for decompression */

struct Decompress_info_struct {
/*
 * These fields shall be established by the user interface before
 * calling jpeg_decompress.
 * Most parameters can be set to reasonable defaults by j_d_defaults.
 * Note that the UI must supply the storage for the main methods struct,
 * though it sets only a few of the methods there.
 */
        decompress_methods_ptr methods; /* Points to list of methods to use */

        external_methods_ptr emethods; /* Points to list of methods to use */

        JFILEREF input_file;    /* tells input routines where to read JPEG */
        IFILEREF output_file;   /* tells output routines where to write image */

        /* these can be set at d_ui_method_selection time: */

        COLOR_SPACE out_color_space; /* colorspace of output */

        double output_gamma;    /* image gamma wanted in output */

        boolean quantize_colors; /* T if output is a colormapped format */
        /* the following are ignored if not quantize_colors: */
        boolean two_pass_quantize;      /* use two-pass color quantization? */
        boolean use_dithering;          /* want color dithering? */
        int desired_number_of_colors;   /* max number of colors to use */

        boolean do_block_smoothing; /* T = apply cross-block smoothing */
        boolean do_pixel_smoothing; /* T = apply post-upsampling smoothing */

/*
 * These fields are used for efficient buffering of data between read_jpeg_data
 * and the entropy decoding object.  By using a shared buffer, we avoid copying
 * data and eliminate the need for an "unget" operation at the end of a scan.
 * The actual source of the data is known only to read_jpeg_data; see the
 * JGETC macro, below.
 * Note: the user interface is expected to allocate the input_buffer and
 * initialize bytes_in_buffer to 0.  Also, for JFIF/raw-JPEG input, the UI
 * actually supplies the read_jpeg_data method.  This is all handled by
 * j_d_defaults in a typical implementation.
 */
        char * input_buffer;    /* start of buffer (private to input code) */
        char * next_input_byte; /* => next Byte to read from buffer */
        int bytes_in_buffer;    /* # of bytes remaining in buffer */

/*
 * These fields are set by read_file_header or read_scan_header
 */
        long image_width;       /* overall image width */
        long image_height;      /* overall image height */

        short data_precision;   /* bits of precision in image data */

        COLOR_SPACE jpeg_color_space; /* colorspace of JPEG file */

        /* These three values are not used by the JPEG code, merely copied */
        /* from the JFIF APP0 marker (if any). */
        UINT8 density_unit;     /* JFIF code for pixel size units */
        UINT16 X_density;       /* Horizontal pixel density */
        UINT16 Y_density;       /* Vertical pixel density */

        short num_components;   /* # of color components in JPEG image */
        jpeg_component_info * comp_info;
        /* comp_info[i] describes component that appears i'th in SOF */

        QUANT_TBL_PTR quant_tbl_ptrs[NUM_QUANT_TBLS];
        /* ptrs to coefficient quantization tables, or NULL if not defined */

        HUFF_TBL * dc_huff_tbl_ptrs[NUM_HUFF_TBLS];
        HUFF_TBL * ac_huff_tbl_ptrs[NUM_HUFF_TBLS];
        /* ptrs to Huffman coding tables, or NULL if not defined */

        UINT8 arith_dc_L[NUM_ARITH_TBLS]; /* L values for DC arith-coding tables */
        UINT8 arith_dc_U[NUM_ARITH_TBLS]; /* U values for DC arith-coding tables */
        UINT8 arith_ac_K[NUM_ARITH_TBLS]; /* Kx values for AC arith-coding tables */

        boolean arith_code;     /* TRUE=arithmetic coding, FALSE=Huffman */
        boolean CCIR601_sampling; /* TRUE=first samples are cosited */

        UINT16 restart_interval;/* MCUs per restart interval, or 0 for no restart */

/*
 * These fields are computed during jpeg_decompress startup
 */
        short max_h_samp_factor; /* largest h_samp_factor */
        short max_v_samp_factor; /* largest v_samp_factor */

        short color_out_comps;  /* # of color components output by color_convert */
                                /* (need not match num_components) */
        short final_out_comps;  /* # of color components sent to put_pixel_rows */
        /* (1 when quantizing colors, else same as color_out_comps) */

        JSAMPLE * sample_range_limit; /* table for fast range-limiting */

/*
 * When quantizing colors, the color quantizer leaves a pointer to the output
 * colormap in these fields.  The colormap is valid from the time put_color_map
 * is called (must be before any put_pixel_rows calls) until shutdown (more
 * specifically, until free_all is called to release memory).
 */
        int actual_number_of_colors; /* actual number of entries */
        JSAMPARRAY colormap;    /* NULL if not valid */
        /* map has color_out_comps rows * actual_number_of_colors columns */

/*
 * These fields may be useful for progress monitoring
 */

        int total_passes;       /* number of passes expected */
        int completed_passes;   /* number of passes completed so far */

/*
 * These fields are valid during any one scan
 */
        short comps_in_scan;    /* # of JPEG components input this time */
        jpeg_component_info * cur_comp_info[MAX_COMPS_IN_SCAN];
        /* *cur_comp_info[i] describes component that appears i'th in SOS */

        long MCUs_per_row;      /* # of MCUs across the image */
        long MCU_rows_in_scan;  /* # of MCU rows in the image */

        short blocks_in_MCU;    /* # of DCT blocks per MCU */
        short MCU_membership[MAX_BLOCKS_IN_MCU];
        /* MCU_membership[i] is index in cur_comp_info of component owning */
        /* i'th block in an MCU */

        /* these fields are private data for the entropy encoder */
        JCOEF last_dc_val[MAX_COMPS_IN_SCAN]; /* last DC coef for each comp */
        JCOEF last_dc_diff[MAX_COMPS_IN_SCAN]; /* last DC diff for each comp */
        UINT16 restarts_to_go;  /* MCUs left in this restart interval */
        short next_restart_num; /* # of next RSTn marker (0..7) */
};

typedef struct Decompress_info_struct * decompress_info_ptr;


/* Macros for reading data from the decompression input buffer */

#ifdef CHAR_IS_UNSIGNED
#define JGETC(cinfo)    ( --(cinfo)->bytes_in_buffer < 0 ? \
                         (*(cinfo)->methods->read_jpeg_data) (cinfo) : \
                         (int) (*(cinfo)->next_input_byte++) )
#else
#define JGETC(cinfo)    ( --(cinfo)->bytes_in_buffer < 0 ? \
                         (*(cinfo)->methods->read_jpeg_data) (cinfo) : \
                         (int) (*(cinfo)->next_input_byte++) & 0xFF )
#endif

#define JUNGETC(ch,cinfo)  ((cinfo)->bytes_in_buffer++, \
                            *(--((cinfo)->next_input_byte)) = (char) (ch))

#define MIN_UNGET       4       /* may always do at least 4 JUNGETCs */


/* A virtual image has a control block whose contents are private to the
 * memory manager module (and may differ between managers).  The rest of the
 * code only refers to virtual images by these pointer types, and never
 * dereferences the pointer.
 */

typedef struct big_sarray_control * big_sarray_ptr;
typedef struct big_barray_control * big_barray_ptr;

/* Although a real ANSI C compiler can deal perfectly well with pointers to
 * unspecified structures (see "incomplete types" in the spec), a few pre-ANSI
 * and pseudo-ANSI compilers get confused.  To keep one of these bozos happy,
 * add -DINCOMPLETE_TYPES_BROKEN to CFLAGS in your Makefile.  Then we will
 * pseudo-define the structs as containing a single "dummy" field.
 * The memory managers #define AM_MEMORY_MANAGER before including this file,
 * so that they can make their own definitions of the structs.
 */

#ifdef INCOMPLETE_TYPES_BROKEN
#ifndef AM_MEMORY_MANAGER
struct big_sarray_control { long dummy; };
struct big_barray_control { long dummy; };
#endif
#endif


/* Method types that need typedefs */

typedef METHOD(void, MCU_output_method_ptr, (compress_info_ptr cinfo,
                                             JBLOCK *MCU_data));
typedef METHOD(void, MCU_output_caller_ptr, (compress_info_ptr cinfo,
                                             MCU_output_method_ptr output_method));
typedef METHOD(void, downsample_ptr, (compress_info_ptr cinfo,
                                      int which_component,
                                      long input_cols, int input_rows,
                                      long output_cols, int output_rows,
                                      JSAMPARRAY above,
                                      JSAMPARRAY input_data,
                                      JSAMPARRAY below,
                                      JSAMPARRAY output_data));
typedef METHOD(void, upsample_ptr, (decompress_info_ptr cinfo,
                                    int which_component,
                                    long input_cols, int input_rows,
                                    long output_cols, int output_rows,
                                    JSAMPARRAY above,
                                    JSAMPARRAY input_data,
                                    JSAMPARRAY below,
                                    JSAMPARRAY output_data));
typedef METHOD(void, quantize_method_ptr, (decompress_info_ptr cinfo,
                                           int num_rows,
                                           JSAMPIMAGE input_data,
                                           JSAMPARRAY output_workspace));
typedef METHOD(void, quantize_caller_ptr, (decompress_info_ptr cinfo,
                                           quantize_method_ptr quantize_method));


/* These structs contain function pointers for the various JPEG methods. */

/* Routines to be provided by the surrounding application, rather than the
 * portable JPEG code proper.  These are the same for compression and
 * decompression.
 */

struct External_methods_struct {
        /* User interface: error exit and trace message routines */
        /* NOTE: the string msgtext parameters will eventually be replaced
         * by an enumerated-type code so that non-English error messages
         * can be substituted easily.  This will not be done until all the
         * code is in place, so that we know what messages are needed.
         */
        METHOD(void, error_exit, (const char *msgtext));
        METHOD(void, trace_message, (const char *msgtext));

        /* Working data for error/trace facility */
        /* See macros below for the usage of these variables */
        int trace_level;        /* level of detail of tracing messages */
        /* Use level 0 for important warning messages (nonfatal errors) */
        /* Use levels 1, 2, 3 for successively more detailed trace options */

        /* For recoverable corrupt-data errors, we emit a warning message and
         * keep going.  A surrounding application can check for bad data by
         * seeing if num_warnings is nonzero at the end of processing.
         */
        long num_warnings;      /* number of corrupt-data warnings */
        int first_warning_level; /* trace level for first warning */
        int more_warning_level; /* trace level for subsequent warnings */

        int message_parm[8];    /* store numeric parms for messages here */

        /* Memory management */
        /* NB: alloc routines never return NULL. They exit to */
        /* error_exit if not successful. */
        METHOD(void *, alloc_small, (size_t sizeofobject));
        METHOD(void, free_small, (void *ptr));
        METHOD(void FAR *, alloc_medium, (size_t sizeofobject));
        METHOD(void, free_medium, (void FAR *ptr));
        METHOD(JSAMPARRAY, alloc_small_sarray, (long samplesperrow,
                                                long numrows));
        METHOD(void, free_small_sarray, (JSAMPARRAY ptr));
        METHOD(JBLOCKARRAY, alloc_small_barray, (long blocksperrow,
                                                 long numrows));
        METHOD(void, free_small_barray, (JBLOCKARRAY ptr));
        METHOD(big_sarray_ptr, request_big_sarray, (long samplesperrow,
                                                    long numrows,
                                                    long unitheight));
        METHOD(big_barray_ptr, request_big_barray, (long blocksperrow,
                                                    long numrows,
                                                    long unitheight));
        METHOD(void, alloc_big_arrays, (long extra_small_samples,
                                        long extra_small_blocks,
                                        long extra_medium_space));
        METHOD(JSAMPARRAY, access_big_sarray, (big_sarray_ptr ptr,
                                               long start_row,
                                               boolean writable));
        METHOD(JBLOCKARRAY, access_big_barray, (big_barray_ptr ptr,
                                                long start_row,
                                                boolean writable));
        METHOD(void, free_big_sarray, (big_sarray_ptr ptr));
        METHOD(void, free_big_barray, (big_barray_ptr ptr));
        METHOD(void, free_all, (void));

        long max_memory_to_use; /* maximum amount of memory to use */
};

/* Macros to simplify using the error and trace message stuff */
/* The first parameter is generally cinfo->emethods */

/* Fatal errors (print message and exit) */
#define ERREXIT(emeth,msg)              ((*(emeth)->error_exit) (msg))
#define ERREXIT1(emeth,msg,p1)          ((emeth)->message_parm[0] = (p1), \
                                         (*(emeth)->error_exit) (msg))
#define ERREXIT2(emeth,msg,p1,p2)       ((emeth)->message_parm[0] = (p1), \
                                         (emeth)->message_parm[1] = (p2), \
                                         (*(emeth)->error_exit) (msg))
#define ERREXIT3(emeth,msg,p1,p2,p3)    ((emeth)->message_parm[0] = (p1), \
                                         (emeth)->message_parm[1] = (p2), \
                                         (emeth)->message_parm[2] = (p3), \
                                         (*(emeth)->error_exit) (msg))
#define ERREXIT4(emeth,msg,p1,p2,p3,p4) ((emeth)->message_parm[0] = (p1), \
                                         (emeth)->message_parm[1] = (p2), \
                                         (emeth)->message_parm[2] = (p3), \
                                         (emeth)->message_parm[3] = (p4), \
                                         (*(emeth)->error_exit) (msg))

#define MAKESTMT(stuff)         do { stuff } while (0)

/* Nonfatal errors (we'll keep going, but the data is probably corrupt) */
/* Note that warning count is incremented as a side-effect! */
#define WARNMS(emeth,msg)    \
  MAKESTMT( if ((emeth)->trace_level >= ((emeth)->num_warnings++ ? \
                (emeth)->more_warning_level : (emeth)->first_warning_level)){ \
                (*(emeth)->trace_message) (msg); } )
#define WARNMS1(emeth,msg,p1)    \
  MAKESTMT( if ((emeth)->trace_level >= ((emeth)->num_warnings++ ? \
                (emeth)->more_warning_level : (emeth)->first_warning_level)){ \
                (emeth)->message_parm[0] = (p1); \
                (*(emeth)->trace_message) (msg); } )
#define WARNMS2(emeth,msg,p1,p2)    \
  MAKESTMT( if ((emeth)->trace_level >= ((emeth)->num_warnings++ ? \
                (emeth)->more_warning_level : (emeth)->first_warning_level)){ \
                (emeth)->message_parm[0] = (p1); \
                (emeth)->message_parm[1] = (p2); \
                (*(emeth)->trace_message) (msg); } )

/* Informational/debugging messages */
#define TRACEMS(emeth,lvl,msg)    \
  MAKESTMT( if ((emeth)->trace_level >= (lvl)) { \
                (*(emeth)->trace_message) (msg); } )
#define TRACEMS1(emeth,lvl,msg,p1)    \
  MAKESTMT( if ((emeth)->trace_level >= (lvl)) { \
                (emeth)->message_parm[0] = (p1); \
                (*(emeth)->trace_message) (msg); } )
#define TRACEMS2(emeth,lvl,msg,p1,p2)    \
  MAKESTMT( if ((emeth)->trace_level >= (lvl)) { \
                (emeth)->message_parm[0] = (p1); \
                (emeth)->message_parm[1] = (p2); \
                (*(emeth)->trace_message) (msg); } )
#define TRACEMS3(emeth,lvl,msg,p1,p2,p3)    \
  MAKESTMT( if ((emeth)->trace_level >= (lvl)) { \
                int * _mp = (emeth)->message_parm; \
                *_mp++ = (p1); *_mp++ = (p2); *_mp = (p3); \
                (*(emeth)->trace_message) (msg); } )
#define TRACEMS4(emeth,lvl,msg,p1,p2,p3,p4)    \
  MAKESTMT( if ((emeth)->trace_level >= (lvl)) { \
                int * _mp = (emeth)->message_parm; \
                *_mp++ = (p1); *_mp++ = (p2); *_mp++ = (p3); *_mp = (p4); \
                (*(emeth)->trace_message) (msg); } )
#define TRACEMS8(emeth,lvl,msg,p1,p2,p3,p4,p5,p6,p7,p8)    \
  MAKESTMT( if ((emeth)->trace_level >= (lvl)) { \
                int * _mp = (emeth)->message_parm; \
                *_mp++ = (p1); *_mp++ = (p2); *_mp++ = (p3); *_mp++ = (p4); \
                *_mp++ = (p5); *_mp++ = (p6); *_mp++ = (p7); *_mp = (p8); \
                (*(emeth)->trace_message) (msg); } )


/* Methods used during JPEG compression. */

struct Compress_methods_struct {
        /* Hook for user interface to get control after input_init */
        METHOD(void, c_ui_method_selection, (compress_info_ptr cinfo));
        /* Hook for user interface to do progress monitoring */
        METHOD(void, progress_monitor, (compress_info_ptr cinfo,
                                        long loopcounter, long looplimit));
        /* Input image reading & conversion to standard form */
        METHOD(void, input_init, (compress_info_ptr cinfo));
        METHOD(void, get_input_row, (compress_info_ptr cinfo,
                                     JSAMPARRAY pixel_row));
        METHOD(void, input_term, (compress_info_ptr cinfo));
        /* Color space and gamma conversion */
        METHOD(void, colorin_init, (compress_info_ptr cinfo));
        METHOD(void, get_sample_rows, (compress_info_ptr cinfo,
                                       int rows_to_read,
                                       JSAMPIMAGE image_data));
        METHOD(void, colorin_term, (compress_info_ptr cinfo));
        /* Expand picture data at edges */
        METHOD(void, edge_expand, (compress_info_ptr cinfo,
                                   long input_cols, int input_rows,
                                   long output_cols, int output_rows,
                                   JSAMPIMAGE image_data));
        /* Downsample pixel values of a single component */
        /* There can be a different downsample method for each component */
        METHOD(void, downsample_init, (compress_info_ptr cinfo));
        downsample_ptr downsample[MAX_COMPS_IN_SCAN];
        METHOD(void, downsample_term, (compress_info_ptr cinfo));
        /* Extract samples in MCU order, process & hand off to output_method */
        /* The input is always exactly N MCU rows worth of data */
        METHOD(void, extract_init, (compress_info_ptr cinfo));
        METHOD(void, extract_MCUs, (compress_info_ptr cinfo,
                                    JSAMPIMAGE image_data,
                                    int num_mcu_rows,
                                    MCU_output_method_ptr output_method));
        METHOD(void, extract_term, (compress_info_ptr cinfo));
        /* Entropy encoding parameter optimization */
        METHOD(void, entropy_optimize, (compress_info_ptr cinfo,
                                        MCU_output_caller_ptr source_method));
        /* Entropy encoding */
        METHOD(void, entropy_encode_init, (compress_info_ptr cinfo));
        METHOD(void, entropy_encode, (compress_info_ptr cinfo,
                                      JBLOCK *MCU_data));
        METHOD(void, entropy_encode_term, (compress_info_ptr cinfo));
        /* JPEG file header construction */
        METHOD(void, write_file_header, (compress_info_ptr cinfo));
        METHOD(void, write_scan_header, (compress_info_ptr cinfo));
        METHOD(void, write_jpeg_data, (compress_info_ptr cinfo,
                                       char *dataptr,
                                       int datacount));
        METHOD(void, write_scan_trailer, (compress_info_ptr cinfo));
        METHOD(void, write_file_trailer, (compress_info_ptr cinfo));
        /* Pipeline control */
        METHOD(void, c_pipeline_controller, (compress_info_ptr cinfo));
        METHOD(void, entropy_output, (compress_info_ptr cinfo,
                                      char *dataptr,
                                      int datacount));
        /* Overall control */
        METHOD(void, c_per_scan_method_selection, (compress_info_ptr cinfo));
};

/* Methods used during JPEG decompression. */

struct Decompress_methods_struct {
        /* Hook for user interface to get control after reading file header */
        METHOD(void, d_ui_method_selection, (decompress_info_ptr cinfo));
        /* Hook for user interface to do progress monitoring */
        METHOD(void, progress_monitor, (decompress_info_ptr cinfo,
                                        long loopcounter, long looplimit));
        /* JPEG file scanning */
        METHOD(void, read_file_header, (decompress_info_ptr cinfo));
        METHOD(boolean, read_scan_header, (decompress_info_ptr cinfo));
        METHOD(int, read_jpeg_data, (decompress_info_ptr cinfo));
        METHOD(void, resync_to_restart, (decompress_info_ptr cinfo,
                                         int marker));
        METHOD(void, read_scan_trailer, (decompress_info_ptr cinfo));
        METHOD(void, read_file_trailer, (decompress_info_ptr cinfo));
        /* Entropy decoding */
        METHOD(void, entropy_decode_init, (decompress_info_ptr cinfo));
        METHOD(void, entropy_decode, (decompress_info_ptr cinfo,
                                      JBLOCKROW *MCU_data));
        METHOD(void, entropy_decode_term, (decompress_info_ptr cinfo));
        /* MCU disassembly: fetch MCUs from entropy_decode, build coef array */
        /* The reverse_DCT step is in the same module for symmetry reasons */
        METHOD(void, disassemble_init, (decompress_info_ptr cinfo));
        METHOD(void, disassemble_MCU, (decompress_info_ptr cinfo,
                                       JBLOCKIMAGE image_data));
        METHOD(void, reverse_DCT, (decompress_info_ptr cinfo,
                                   JBLOCKIMAGE coeff_data,
                                   JSAMPIMAGE output_data, int start_row));
        METHOD(void, disassemble_term, (decompress_info_ptr cinfo));
        /* Cross-block smoothing */
        METHOD(void, smooth_coefficients, (decompress_info_ptr cinfo,
                                           jpeg_component_info *compptr,
                                           JBLOCKROW above,
                                           JBLOCKROW currow,
                                           JBLOCKROW below,
                                           JBLOCKROW output));
        /* Upsample pixel values of a single component */
        /* There can be a different upsample method for each component */
        METHOD(void, upsample_init, (decompress_info_ptr cinfo));
        upsample_ptr upsample[MAX_COMPS_IN_SCAN];
        METHOD(void, upsample_term, (decompress_info_ptr cinfo));
        /* Color space and gamma conversion */
        METHOD(void, colorout_init, (decompress_info_ptr cinfo));
        METHOD(void, color_convert, (decompress_info_ptr cinfo,
                                     int num_rows, long num_cols,
                                     JSAMPIMAGE input_data,
                                     JSAMPIMAGE output_data));
        METHOD(void, colorout_term, (decompress_info_ptr cinfo));
        /* Color quantization */
        METHOD(void, color_quant_init, (decompress_info_ptr cinfo));
        METHOD(void, color_quantize, (decompress_info_ptr cinfo,
                                      int num_rows,
                                      JSAMPIMAGE input_data,
                                      JSAMPARRAY output_data));
        METHOD(void, color_quant_prescan, (decompress_info_ptr cinfo,
                                           int num_rows,
                                           JSAMPIMAGE image_data,
                                           JSAMPARRAY workspace));
        METHOD(void, color_quant_doit, (decompress_info_ptr cinfo,
                                        quantize_caller_ptr source_method));
        METHOD(void, color_quant_term, (decompress_info_ptr cinfo));
        /* Output image writing */
        METHOD(void, output_init, (decompress_info_ptr cinfo));
        METHOD(void, put_color_map, (decompress_info_ptr cinfo,
                                     int num_colors, JSAMPARRAY colormap));
        METHOD(void, put_pixel_rows, (decompress_info_ptr cinfo,
                                      int num_rows,
                                      JSAMPIMAGE pixel_data));
        METHOD(void, output_term, (decompress_info_ptr cinfo));
        /* Pipeline control */
        METHOD(void, d_pipeline_controller, (decompress_info_ptr cinfo));
        /* Overall control */
        METHOD(void, d_per_scan_method_selection, (decompress_info_ptr cinfo));
};


/* External declarations for routines that aren't called via method ptrs. */
/* Note: use "j" as first char of names to minimize namespace pollution. */
/* The PP macro hides prototype parameters from compilers that can't cope. */

#ifdef PROTO
#define PP(arglist)     arglist
#else
#define PP(arglist)     ()
#endif


/* main entry for compression */
EXTERN void jpeg_compress PP((compress_info_ptr cinfo));

/* default parameter setup for compression */
EXTERN void j_c_defaults PP((compress_info_ptr cinfo, int quality,
                             boolean force_baseline));
EXTERN void j_monochrome_default PP((compress_info_ptr cinfo));
EXTERN void j_set_quality PP((compress_info_ptr cinfo, int quality,
                              boolean force_baseline));
/* advanced compression parameter setup aids */
EXTERN void j_add_quant_table PP((compress_info_ptr cinfo, int which_tbl,
                                  const QUANT_VAL *basic_table,
                                  int scale_factor, boolean force_baseline));
EXTERN int j_quality_scaling PP((int quality));

/* main entry for decompression */
EXTERN void jpeg_decompress PP((decompress_info_ptr cinfo));


/* default parameter setup for decompression */
EXTERN void j_d_defaults PP((decompress_info_ptr cinfo,
                             boolean standard_buffering));

/* forward DCT */
EXTERN void j_fwd_dct PP((DCTBLOCK data));
/* inverse DCT */
EXTERN void j_rev_dct PP((DCTBLOCK data));

/* utility routines in jutils.c */
EXTERN long jround_up PP((long a, long b));
EXTERN void jcopy_sample_rows PP((JSAMPARRAY input_array, int source_row,
                                  JSAMPARRAY output_array, int dest_row,
                                  int num_rows, long num_cols));
EXTERN void jcopy_block_row PP((JBLOCKROW input_row, JBLOCKROW output_row,
                                long num_blocks));
EXTERN void jzero_far PP((void FAR * target, size_t bytestozero));

/* method selection routines for compression modules */
EXTERN void jselcpipeline PP((compress_info_ptr cinfo)); /* jcpipe.c */
EXTERN void jselchuffman PP((compress_info_ptr cinfo)); /* jchuff.c */
EXTERN void jselcarithmetic PP((compress_info_ptr cinfo)); /* jcarith.c */
EXTERN void jselexpand PP((compress_info_ptr cinfo)); /* jcexpand.c */
EXTERN void jseldownsample PP((compress_info_ptr cinfo)); /* jcsample.c */
EXTERN void jselcmcu PP((compress_info_ptr cinfo)); /* jcmcu.c */
EXTERN void jselccolor PP((compress_info_ptr cinfo));   /* jccolor.c */
/* The user interface should call one of these to select input format: */
EXTERN void jselrgif PP((compress_info_ptr cinfo)); /* jrdgif.c */
EXTERN void jselrppm PP((compress_info_ptr cinfo)); /* jrdppm.c */
EXTERN void jselrrle PP((compress_info_ptr cinfo)); /* jrdrle.c */
EXTERN void jselrtarga PP((compress_info_ptr cinfo)); /* jrdtarga.c */
/* and one of these to select output header format: */
EXTERN void jselwjfif PP((compress_info_ptr cinfo)); /* jwrjfif.c */

/* method selection routines for decompression modules */
EXTERN void jseldpipeline PP((decompress_info_ptr cinfo)); /* jdpipe.c */
EXTERN void jseldhuffman PP((decompress_info_ptr cinfo)); /* jdhuff.c */
EXTERN void jseldarithmetic PP((decompress_info_ptr cinfo)); /* jdarith.c */
EXTERN void jseldmcu PP((decompress_info_ptr cinfo)); /* jdmcu.c */
EXTERN void jselbsmooth PP((decompress_info_ptr cinfo)); /* jbsmooth.c */
EXTERN void jselupsample PP((decompress_info_ptr cinfo)); /* jdsample.c */
EXTERN void jseldcolor PP((decompress_info_ptr cinfo)); /* jdcolor.c */
EXTERN void jsel1quantize PP((decompress_info_ptr cinfo)); /* jquant1.c */
EXTERN void jsel2quantize PP((decompress_info_ptr cinfo)); /* jquant2.c */
/* The user interface should call one of these to select input format: */
EXTERN void jselrjfif PP((decompress_info_ptr cinfo)); /* jrdjfif.c */
/* and one of these to select output image format: */
EXTERN void jselwgif PP((decompress_info_ptr cinfo)); /* jwrgif.c */
EXTERN void jselwppm PP((decompress_info_ptr cinfo)); /* jwrppm.c */
EXTERN void jselwrle PP((decompress_info_ptr cinfo)); /* jwrrle.c */
EXTERN void jselwtarga PP((decompress_info_ptr cinfo)); /* jwrtarga.c */

/* method selection routines for system-dependent modules */
EXTERN void jselerror PP((external_methods_ptr emethods)); /* jerror.c */
EXTERN void jselmemmgr PP((external_methods_ptr emethods)); /* jmemmgr.c */

/* We assume that right shift corresponds to signed division by 2 with
 * rounding towards minus infinity.  This is correct for typical "arithmetic
 * shift" instructions that shift in copies of the sign bit.  But some
 * C compilers implement >> with an unsigned shift.  For these machines you
 * must define RIGHT_SHIFT_IS_UNSIGNED.
 * RIGHT_SHIFT provides a proper signed right shift of an INT32 quantity.
 * It is only applied with constant shift counts.  SHIFT_TEMPS must be
 * included in the variables of any routine using RIGHT_SHIFT.
 */

#ifdef RIGHT_SHIFT_IS_UNSIGNED
#define SHIFT_TEMPS     INT32 shift_temp;
#define RIGHT_SHIFT(x,shft)  \
        ((shift_temp = (x)) < 0 ? \
         (shift_temp >> (shft)) | ((~((INT32) 0)) << (32-(shft))) : \
         (shift_temp >> (shft)))
#else
#define SHIFT_TEMPS
#define RIGHT_SHIFT(x,shft)     ((x) >> (shft))
#endif


/* Miscellaneous useful macros */

#undef MAX
#define MAX(a,b)        ((a) > (b) ? (a) : (b))
#undef MIN
#define MIN(a,b)        ((a) < (b) ? (a) : (b))


#define RST0    0xD0            /* RST0 marker code */
/*
 * jmemsys.h
 *
 * Copyright (C) 1992, Thomas G. Lane.
 * This file is part of the Independent JPEG Group's software.
 * For conditions of distribution and use, see the accompanying README file.
 *
 * This include file defines the interface between the system-independent
 * and system-dependent portions of the JPEG memory manager.  (The system-
 * independent portion is jmemmgr.c; there are several different versions
 * of the system-dependent portion, and of this file for that matter.)
 *
 * This is a "generic" skeleton that may need to be modified for particular
 * systems.  It should be usable as-is on the majority of non-MSDOS machines.
 */


/*
 * These two functions are used to allocate and release small chunks of
 * memory (typically the total amount requested through jget_small is
 * no more than 20Kb or so).  Behavior should be the same as for the
 * standard library functions malloc and free; in particular, jget_small
 * returns NULL on failure.  On most systems, these ARE malloc and free.
 * On an 80x86 machine using small-data memory model, these manage near heap.
 */

EXTERN void * jget_small PP((size_t sizeofobject));
EXTERN void jfree_small PP((void * object));

/*
 * These two functions are used to allocate and release large chunks of
 * memory (up to the total free space designated by jmem_available).
 * The interface is the same as above, except that on an 80x86 machine,
 * far pointers are used.  On other systems these ARE the same as above.
 */

#ifdef NEED_FAR_POINTERS        /* typically not needed except on 80x86 */
EXTERN void FAR * jget_large PP((size_t sizeofobject));
EXTERN void jfree_large PP((void FAR * object));
#else
#define jget_large(sizeofobject)        jget_small(sizeofobject)
#define jfree_large(object)             jfree_small(object)
#endif

/*
 * The macro MAX_ALLOC_CHUNK designates the maximum number of bytes that may
 * be requested in a single call on jget_large (and jget_small for that
 * matter, but that case should never come into play).  This macro is needed
 * to model the 64Kb-segment-size limit of far addressing on 80x86 machines.
 * On machines with flat address spaces, any large constant may be used here.
 */

#define MAX_ALLOC_CHUNK         1000000000L

/*
 * This routine computes the total space available for allocation by
 * jget_large.  If more space than this is needed, backing store will be used.
 * NOTE: any memory already allocated must not be counted.
 *
 * There is a minimum space requirement, corresponding to the minimum
 * feasible buffer sizes; jmemmgr.c will request that much space even if
 * jmem_available returns zero.  The maximum space needed, enough to hold
 * all working storage in memory, is also passed in case it is useful.
 *
 * It is OK for jmem_available to underestimate the space available (that'll
 * just lead to more backing-store access than is really necessary).
 * However, an overestimate will lead to failure.  Hence it's wise to subtract
 * a slop factor from the true available space, especially if jget_small space
 * comes from the same pool.  5% should be enough.
 *
 * On machines with lots of virtual memory, any large constant may be returned.
 * Conversely, zero may be returned to always use the minimum amount of memory.
 */

EXTERN long jmem_available PP((long min_bytes_needed, long max_bytes_needed));


/*
 * This structure holds whatever state is needed to access a single
 * backing-store object.  The read/write/close method pointers are called
 * by jmemmgr.c to manipulate the backing-store object; all other fields
 * are private to the system-dependent backing store routines.
 */

#define TEMP_NAME_LENGTH   64   /* max length of a temporary file's name */

typedef struct backing_store_struct * backing_store_ptr;

typedef struct backing_store_struct {
        /* Methods for reading/writing/closing this backing-store object */
        METHOD(void, read_backing_store, (backing_store_ptr info,
                                          void FAR * buffer_address,
                                          long file_offset, long byte_count));
        METHOD(void, write_backing_store, (backing_store_ptr info,
                                           void FAR * buffer_address,
                                           long file_offset, long byte_count));
        METHOD(void, close_backing_store, (backing_store_ptr info));
        /* Private fields for system-dependent backing-store management */
        /* For a typical implementation with temp files, we might need: */
        FILE * temp_file;       /* stdio reference to temp file */
        char temp_name[TEMP_NAME_LENGTH]; /* name of temp file */
      } backing_store_info;

/*
 * Initial opening of a backing-store object.  This must fill in the
 * read/write/close pointers in the object.  The read/write routines
 * may take an error exit if the specified maximum file size is exceeded.
 * (If jmem_available always returns a large value, this routine can just
 * take an error exit.)
 */

EXTERN void jopen_backing_store PP((backing_store_ptr info,
                                    long total_bytes_needed));


/*
 * These routines take care of any system-dependent initialization and
 * cleanup required.  The system methods struct address should be saved
 * by jmem_init in case an error exit must be taken.  jmem_term may assume
 * that all requested memory has been freed and that all opened backing-
 * store objects have been closed.
 * NB: jmem_term may be called more than once, and must behave reasonably
 * if that happens.
 */

EXTERN void jmem_init PP((external_methods_ptr emethods));
EXTERN void jmem_term PP((void));

#endif /* JPEG_H */

#ifdef FIX      /* Fudge to get jpeglib.c to compile without changes */
#undef FIX
#endif
#endif